theory Metatheory
imports Typing Semantics

begin

lemma vsubst_equal_sanity:
  assumes "vsubst_ty (vsubst_ty (TyFreeVar x) i \<tau>a) 0 (vsubst_ty (TyFreeVar x) (Suc i) \<tau>d) =
           vsubst_ty (TyFreeVar x) i \<tau>"
  and "\<not> x free in type \<tau>"
  and "\<not> x free in type \<tau>a"
  and "\<not> x free in type \<tau>d"
  and "set (free_db_ty \<tau>) \<subseteq> {i}"
  and "set (free_db_ty \<tau>a) \<subseteq> {i}"
  and "set (free_db_ty \<tau>d) \<subseteq> {0, Suc i}"
  and "set (free_db_ty \<tau>') = {}"
  shows "vsubst_ty (vsubst_ty \<tau>' i \<tau>a) 0 (vsubst_ty \<tau>' (Suc i) \<tau>d) = vsubst_ty \<tau>' i \<tau>"
proof -
  let ?f = "%ct. vsubst_ty (vsubst_ty (Rep_cty ct) i \<tau>a) 0 (vsubst_ty (Rep_cty ct) (Suc i) \<tau>d)"
  let ?g = "%ct. vsubst_ty (Rep_cty ct) i \<tau>"
  let ?\<tau>'' = "Rep_cty (Abs_cty \<tau>')"
  have "subst_func (%ct. vsubst_ty (Rep_cty ct) (Suc i) \<tau>d)"
    using subst_func_subst[of "%ct. \<tau>d"] by auto
  moreover
  have "subst_func (%ct. vsubst_ty (Rep_cty ct) i \<tau>a)"
    using subst_func_subst[of "%ct. \<tau>a"] by auto
  ultimately
  have "subst_func ?f" using subst_func_subst by auto
  moreover
  have "subst_func ?g" using subst_func_subst[of "%ct. \<tau>"] by auto
  moreover
  have "not_free_in_func x ?f" using prems by (auto simp add: not_free_subst_ty)
  moreover
  have "not_free_in_func x ?g" using prems by (auto simp add: not_free_subst_ty)
  moreover
  have "set (free_db_ty (TyFreeVar x)) = {}" by auto
  hence "TyFreeVar x \<in> cty" by (auto simp add: cty_def)
  hence "Rep_cty (Abs_cty (TyFreeVar x)) = TyFreeVar x" by auto
  hence "?f (Abs_cty (TyFreeVar x)) = ?g (Abs_cty (TyFreeVar x))" by auto
  ultimately
  have "vsubst_ty (vsubst_ty ?\<tau>'' i \<tau>a) 0 (vsubst_ty ?\<tau>'' (Suc i) \<tau>d) = vsubst_ty ?\<tau>'' i \<tau>"
    by (rule subst_func_equal_ty)
  moreover
  have "\<tau>' \<in> cty" using prems by (auto simp add: cty_def)
  hence "?\<tau>'' = \<tau>'" by auto
  ultimately
  show ?thesis by auto
qed

lemma weakening_tm:
  assumes "\<Gamma>;\<Delta> \<turnstile> e : \<tau>"
  and "(\<Gamma> \<union> \<Gamma>');\<Delta> \<Turnstile> OK"
  shows "(\<Gamma> \<union> \<Gamma>');\<Delta> \<turnstile> e : \<tau>"
using prems proof (induct arbitrary: \<Gamma>' M')
  case t_unit thus ?case by blast
next
  case (t_var \<Gamma> \<tau> x) thus ?case by auto
next
  case (t_abs L \<Delta>x \<Gamma>x \<tau>_a \<tau>_r e_b \<Gamma>x')
  let ?L' = "L \<union> dom (\<Gamma>x \<union> \<Gamma>x')"
  show ?case proof
    have "finite (dom (\<Gamma>x \<union> \<Gamma>x'))" using ty_wf_env wf_env_fin prems by auto
    thus "finite ?L'" using t_abs by auto
  next
    { fix x
      assume Hx: "\<not> x free in e_b \<and> x \<notin> ?L' \<and> x \<notin> dom (\<Gamma>x \<union> \<Gamma>x')"
      hence "x \<notin> dom \<Gamma>x" by (auto simp add: dom_def)
      hence "(\<Gamma>x,(x:\<tau>_a) \<union> \<Gamma>x');\<Delta>x \<Turnstile> OK \<longrightarrow> (\<Gamma>x,(x:\<tau>_a) \<union> \<Gamma>x');\<Delta>x \<turnstile> freshen_tm x e_b : \<tau>_r"
        using t_abs Hx by blast
      moreover
      have "(\<Gamma>x \<union> \<Gamma>x'),(x:\<tau>_a);\<Delta>x \<Turnstile> OK" using wf_env_weakening[of "\<Gamma>x \<union> \<Gamma>x'"] prems by auto
      ultimately 
      have "(\<Gamma>x \<union> \<Gamma>x'),(x:\<tau>_a);\<Delta>x \<turnstile> freshen_tm x e_b : \<tau>_r" using t_abs Hx by auto
    }
    thus "\<forall>x. \<not> x free in e_b \<and> x \<notin> ?L' \<and> x \<notin> dom (\<Gamma>x \<union> \<Gamma>x') \<longrightarrow>
           (\<Gamma>x \<union> \<Gamma>x'),(x:\<tau>_a);\<Delta>x \<turnstile> freshen_tm x e_b : \<tau>_r" by auto
  qed assumption
next
  case (t_poly L \<Delta> \<Gamma> \<tau> e \<Gamma>')
  let ?L' = "L \<union> dom (\<Gamma> \<union> \<Gamma>') \<union> dom \<Delta>"
  show ?case proof
    have "finite (dom (\<Gamma> \<union> \<Gamma>'))" using ty_wf_env wf_env_fin prems by auto
    moreover
    hence "finite (dom \<Delta>)" using ty_wf_env_ty wf_env_ty_fin prems by blast
    ultimately show "finite ?L'" using t_poly by auto
  next
    { fix x
      assume Hx: "\<not> x free in term e \<and> \<not> x free in type \<tau> \<and> x \<notin> ?L'
                  \<and> \<not> x free in env (\<Gamma> \<union> \<Gamma>') \<and> \<not> \<Delta> defines x"
      hence "\<not> x free in env \<Gamma>" by (auto simp add: free_ty_env_def)
      hence "(\<Gamma> \<union> \<Gamma>');\<Delta>,(x:\<star>) \<Turnstile> OK \<longrightarrow> (\<Gamma> \<union> \<Gamma>');\<Delta>,(x:\<star>) \<turnstile> freshen_tmty x e : freshen_ty x \<tau>"
        using t_poly Hx by blast
      moreover
      have "(\<Gamma> \<union> \<Gamma>'); \<Delta>,(x:\<star>) \<Turnstile> OK" using prems ok_weakening_tyenv by auto
      ultimately 
      have "(\<Gamma> \<union> \<Gamma>'); \<Delta>,(x:\<star>) \<turnstile> freshen_tmty x e : freshen_ty x \<tau>"
        using prems by auto
    }
    thus "\<forall>x. \<not> x free in term e \<and> \<not> x free in type \<tau> \<and> x \<notin> ?L' \<and> x \<notin> free_ty_env (\<Gamma> \<union> \<Gamma>') \<and> \<not> \<Delta> defines x
      \<longrightarrow> (\<Gamma> \<union> \<Gamma>');\<Delta>,(x:\<star>) \<turnstile> freshen_tmty x e : freshen_ty x \<tau>" by auto
  qed assumption
qed auto

lemma weakening_ty:
  assumes "\<Gamma>;\<Delta> \<turnstile> e : \<tau>"
  and "\<Gamma>;(\<Delta>\<union>\<Delta>') \<Turnstile> OK"
  shows "\<Gamma>;(\<Delta>\<union>\<Delta>') \<turnstile> e : \<tau>"
using prems proof (induct arbitrary: \<Delta>')
  case (t_tyapp \<Delta>c \<Gamma>c \<tau>c \<tau>c1 ec1 \<Delta>c')
  thus ?case using ok_weakening_ty_union wf_env_wf_env_ty by auto
next
  case (t_abs L \<Delta>c \<Gamma>c \<tau>c1 \<tau>c2 ec \<Delta>c')
  let ?L' = "L"
  have H1: "\<Gamma>c;(\<Delta>c \<union> \<Delta>c') \<Turnstile> OK" using prems wf_env_wf_env_ty by auto
  have H2: "(\<Delta>c \<union> \<Delta>c') \<Turnstile> \<tau>c1" using prems ok_weakening_ty_union wf_env_wf_env_ty by auto
  have "\<Gamma>c;(\<Delta>c \<union> \<Delta>c') \<Turnstile> OK" by assumption
  moreover
  have "finite ?L'" by assumption
  moreover
  have "(\<Delta>c \<union> \<Delta>c') \<Turnstile> \<tau>c1" using H2 by assumption
  moreover
    {
      fix x
      assume "\<not> x free in ec"
        and "x \<notin> ?L'"
        and "\<not> \<Gamma>c defines x"
      moreover
      hence "\<Gamma>c,(x:\<tau>c1);(\<Delta>c \<union> \<Delta>c') \<Turnstile> OK" using H1 H2 wf_env_weakening by auto
      ultimately
      have "\<Gamma>c,(x:\<tau>c1);(\<Delta>c \<union> \<Delta>c') \<turnstile> freshen_tm x ec : \<tau>c2" using t_abs by auto
      }
    hence "\<forall>x. x \<notin> set (free_tm ec) \<and> x \<notin> ?L' \<and> x \<notin> Environ.dom \<Gamma>c \<longrightarrow>
        \<Gamma>c,(x:\<tau>c1);(\<Delta>c \<union> \<Delta>c') \<turnstile> freshen_tm x ec : \<tau>c2" by auto
    ultimately
    show ?case by auto  
next
  case (t_poly L \<Delta>c \<Gamma>c \<tau>c vc \<Delta>c')
  let ?L' = "L"
  have "\<Gamma>c;(\<Delta>c \<union> \<Delta>c') \<Turnstile> OK" using prems by auto
  moreover
  have "finite ?L'" by assumption
  moreover
  have "value vc" by assumption
  moreover
  {
    fix a
    assume "\<not> a free in term vc"
      and "\<not> a free in type \<tau>c"
      and "a \<notin> ?L'"
      and "\<not> a free in env \<Gamma>c"
      and "\<not> (\<Delta>c \<union> \<Delta>c') defines a"
    moreover
    hence "\<not> \<Delta>c defines a" by (auto simp add: dom_def)
    moreover
    have "\<Gamma>c;(\<Delta>c \<union> \<Delta>c'),(a:\<star>) \<Turnstile> OK" using ok_weakening_tyenv prems by auto
    hence "\<Gamma>c;(\<Delta>c,(a:\<star>) \<union> \<Delta>c') \<Turnstile> OK" by auto
    ultimately
    have "\<Gamma>c;(\<Delta>c,(a:\<star>) \<union> \<Delta>c') \<turnstile> freshen_tmty a vc : freshen_ty a \<tau>c" using t_poly by auto
  }
  hence "\<forall>a. a \<notin> set (free_tmty vc) \<and>
      a \<notin> set (free_ty \<tau>c) \<and>
      a \<notin> ?L' \<and> a \<notin> free_ty_env \<Gamma>c \<and> a \<notin> Environ.dom (\<Delta>c \<union> \<Delta>c') \<longrightarrow>
      \<Gamma>c;(\<Delta>c \<union> \<Delta>c'),(a:\<star>) \<turnstile> freshen_tmty a vc : freshen_ty a \<tau>c" by auto
  ultimately
  show ?case by auto
qed auto


lemma weakening:
  assumes "\<Gamma>;\<Delta> \<turnstile> e : \<tau>"
  and "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK"
  shows "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> e : \<tau>"
proof -
  have "(\<Delta> \<union> \<Delta>') \<Turnstile> TY" using prems wf_env_wf_env_ty by auto
  hence "\<Gamma>;(\<Delta> \<union> \<Delta>') \<Turnstile> OK" 
    using ok_weakening_ty_env_gen[of \<Gamma> \<Delta>] ty_wf_env[of \<Gamma> \<Delta>] prems by auto
  hence "\<Gamma>;(\<Delta>\<union>\<Delta>') \<turnstile> e : \<tau>" using weakening_ty prems by auto
  thus ?thesis using prems weakening_tm by auto
qed

lemma substitution:
  fixes n :: nat
  assumes "size e = n"
  and "\<Gamma>;\<Delta> \<turnstile> e' : \<tau>'"
  and "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> vsubst_tm (TmFreeVar x) i e : \<tau>"
  and "\<not> x free in e"
  shows "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e : \<tau>"
using prems proof (induct n arbitrary: e \<tau> i \<Gamma> M \<Delta> rule: nat_less_induct)
  case (1 n_y e_y \<tau>) show ?case
  proof (cases e_y)
    case TmUnit thus ?thesis using ty_wf_env prems by auto
  next
    case (TmFreeVar y) thus ?thesis using ty_wf_env prems by auto
  next
    case (TmVar j)
    show ?thesis proof (cases "j=i")
      case True
      hence "(x\<rhd>\<tau>) \<in> (\<Gamma>,(x:\<tau>'))" using prems by auto
      moreover
      have "\<Gamma>,(x:\<tau>');\<Delta> \<Turnstile> OK" using prems ty_wf_env by auto
      moreover
      hence "(x\<rhd>\<tau>') \<in> (\<Gamma>,(x:\<tau>'))" by auto
      ultimately
      have "\<tau> = \<tau>'" using wf_env_def[of "\<Gamma>,(x:\<tau>')" \<Delta>] by blast
      moreover
      have "vsubst_tm e' i (TmVar j) = e'" using prems by auto
      ultimately
      show "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_y : \<tau>" using TmVar by auto
    next
      assume "j \<noteq> i"
      hence "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> TmVar j : \<tau>" using prems by auto
      thus "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_y : \<tau>" by (cases, auto)
    qed
  next
    case (TmAbs \<tau>_y e_b)
    let ?e_b = "vsubst_tm e' (Suc i) e_b"
    let ?e_bx = "vsubst_tm (TmFreeVar x) (Suc i) e_b"
    have "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> \<lambda>[\<tau>_y]. vsubst_tm (TmFreeVar x) (Suc i) e_b : \<tau>"
      using prems by auto
    thus ?thesis proof
      fix L \<tau>_b
      assume Hgok: "\<Gamma>,(x:\<tau>');\<Delta> \<Turnstile> OK"
        and Hfin: "finite L"
        and Htok: "\<Delta> \<Turnstile> \<tau>_y"
        and Htyp: "\<forall> z. \<not> z free in ?e_bx \<and> z \<notin> L \<and> z \<notin> dom (\<Gamma>,(x:\<tau>')) \<longrightarrow>
                 \<Gamma>,(x:\<tau>'),(z:\<tau>_y);\<Delta> \<turnstile> (vsubst_tm (TmFreeVar z) 0 ?e_bx) : \<tau>_b"
        and Heq: "\<tau> = \<tau>_y \<rightarrow> \<tau>_b"
      let ?L' = "L \<union> dom \<Gamma> \<union> {x} \<union> set (free_tm ?e_bx)"
      have "\<Gamma>;\<Delta> \<turnstile> \<lambda>[\<tau>_y]. ?e_b  : \<tau>_y \<rightarrow> \<tau>_b" proof
        have "\<Gamma>;\<Delta> \<Turnstile> OK" using prems by (auto simp add: ty_wf_env)
        hence "finite (dom \<Gamma>)" by (auto simp add: wf_env_fin)
        thus "finite ?L'" using prems by auto
      next
        { fix z
          assume "\<not> z free in ?e_b"
            and Hz: "z \<notin> ?L'"
            and "\<not> \<Gamma> defines z"
          have A1: "size (freshen_tm z e_b) < n_y" using prems by auto
          have "\<not> \<Gamma> defines z" using Hz by auto
          moreover have "\<Gamma>;\<Delta> \<Turnstile> OK" using prems by (auto simp add: ty_wf_env)
          ultimately have "\<Gamma>,(z:\<tau>_y);\<Delta> \<Turnstile> OK" using prems wf_env_weakening by auto
          hence "\<Gamma>,(z:\<tau>_y);\<Delta> \<turnstile> e' : \<tau>'" using prems
            using weakening_tm[of _ _ _ _ "{(z\<rhd>\<tau>_y)}"] by auto
          hence A2: "({(z\<rhd>\<tau>_y)} \<union> \<Gamma>);\<Delta> \<turnstile> e' : \<tau>'" by auto
          have "z \<notin> L" using Hz by auto
          moreover
          have "\<not> z free in ?e_bx" using Hz by auto
          moreover
          have "z \<notin> dom (\<Gamma>,(x:\<tau>'))" using Hz by (auto simp add: dom_def)
          ultimately
          have "(\<Gamma>,(x:\<tau>'),(z:\<tau>_y));\<Delta> \<turnstile> (freshen_tm z ?e_bx) : \<tau>_b"
            using Htyp by auto
          moreover
          have "\<forall>k. vsubst_tm (TmFreeVar z) k (TmFreeVar x) = (TmFreeVar x)"
            by auto
          ultimately
          have "\<Gamma>,(x:\<tau>'),(z:\<tau>_y);\<Delta> \<turnstile> vsubst_tm (TmFreeVar x) (Suc i) (freshen_tm z e_b) : \<tau>_b"
            by (auto simp add: subst_subst_swap[of "0" "(Suc i)"])
          moreover
          have "\<Gamma>,(x:\<tau>'),(z:\<tau>_y) = \<Gamma>,(z:\<tau>_y),(x:\<tau>')" by auto
          ultimately
          have A3: "\<Gamma>,(z:\<tau>_y),(x:\<tau>');\<Delta> \<turnstile>
            vsubst_tm (TmFreeVar x) (Suc i) (freshen_tm z e_b) : \<tau>_b" by auto
          have A4: "\<not> x free in (freshen_tm z e_b)"
            using prems by (auto simp add: not_free_subst)
          have "\<Gamma>,(z:\<tau>_y);\<Delta> \<turnstile>
            vsubst_tm e' (Suc i) (freshen_tm z e_b) : \<tau>_b"
            using "1.hyps" A1 A2 A3 A4 by auto
          moreover
          have "\<forall>k. vsubst_tm (TmFreeVar z) k e' = e'"
            using prems by (auto simp add: ty_same_subst)
          ultimately
          have "\<Gamma>,(z:\<tau>_y);\<Delta> \<turnstile> freshen_tm z ?e_b : \<tau>_b"
            by (auto simp add: subst_subst_swap)
        }
        thus "\<forall>x. \<not> x free in ?e_b \<and> x \<notin> ?L' \<and> \<not> \<Gamma> defines x\<longrightarrow>
          \<Gamma>,(x:\<tau>_y);\<Delta> \<turnstile> freshen_tm x ?e_b : \<tau>_b" by auto
      next
        show "\<Delta> \<Turnstile> \<tau>_y" by assumption
      next
        show "\<Gamma>;\<Delta> \<Turnstile> OK" using prems ty_wf_env by auto
      qed
      thus "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_y : \<tau>" using prems by auto
    qed
  next
    case (TmProd e)
    let ?e_b = "vsubst_tm e' i e"
    let ?e_bx = "vsubst_tm (TmFreeVar x) i e"
    have "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> \<Lambda>[*]. vsubst_tm (TmFreeVar x) i e : \<tau>"
      using prems by auto
    then obtain \<tau>b L where Heq: "\<tau> = \<forall>.\<tau>b"
      and Hfin: "finite L"
      and Hval: "value ?e_bx"
      and Htyp: "\<forall> z. \<not> z free in term ?e_bx \<and> \<not> z free in type \<tau>b \<and> z \<notin> L \<and> z \<notin> free_ty_env (\<Gamma>,(x:\<tau>'))
                 \<and> \<not> \<Delta> defines z \<longrightarrow>
                \<Gamma>,(x:\<tau>');\<Delta>,(z:\<star>) \<turnstile> (vsubst_tmty (TyFreeVar z) 0 ?e_bx) : vsubst_ty (TyFreeVar z) 0 \<tau>b"
      using  typing_poly_elim[of "\<Gamma>,(x:\<tau>')" \<Delta> ?e_bx] by auto
    let ?L' = "L \<union> dom \<Gamma> \<union> {x} \<union> dom \<Delta> \<union> set (free_ty \<tau>b) \<union> set (free_ty \<tau>')"
    have "\<Gamma>;\<Delta> \<turnstile> \<Lambda>[*]. ?e_b  : \<forall>.\<tau>b" proof
      have "\<Gamma>;\<Delta> \<Turnstile> OK" using prems by (auto simp add: ty_wf_env)
      hence "finite (dom \<Gamma>)" and "finite (dom \<Delta>)" by (auto simp add: wf_env_fin wf_env_ty_fin)
      thus "finite ?L'" using prems by auto
    next
      have "value e" using prems value_subst_value[of _ _ e] by auto
      thus "value (vsubst_tm e' i e)" using value_subst_value_rev by auto
    next
      { fix z
        assume "\<not> z free in term ?e_b"
          and "\<not> z free in type \<tau>b"
          and Hz: "z \<notin> ?L'"
          and Hf: "z \<notin> free_ty_env \<Gamma>"
          and Hd: "\<not> \<Delta> defines z"
        let ?enew = "freshen_tmty z e"
        let ?\<tau>new = "freshen_ty z \<tau>b"
        have A1: "size ?enew < n_y" using prems by auto
        have "\<not> \<Delta> defines z" using Hz by auto
        moreover have "\<Gamma>;\<Delta> \<Turnstile> OK" using prems by (auto simp add: ty_wf_env)
        ultimately have "\<Gamma>;\<Delta>,(z:\<star>) \<Turnstile> OK" using ok_weakening_tyenv prems by auto
        hence A2: "\<Gamma>;\<Delta>,(z:\<star>) \<turnstile> e' : \<tau>'" using weakening_ty[of \<Gamma> \<Delta> _ _ "{z\<rhd>\<star>}"] prems by auto
        have "\<not> z free in term e"
          using inv_not_free_subst_tm[of z e' _ e] prems by auto
        hence "\<not> z free in term ?e_bx"
          using not_free_subst_tm[of z e "TmFreeVar x"] by auto
        moreover
        have "free_ty_env (\<Gamma>,(x:\<tau>')) = free_ty_env \<Gamma> \<union> set (free_ty \<tau>')"
          by (auto simp add: free_ty_env_def)
        hence "\<not> z free in env (\<Gamma>,(x:\<tau>'))" using prems by auto
        ultimately
        have "z \<notin> set (free_tmty ?e_bx) \<and> z \<notin> set (free_ty \<tau>b) \<and> z \<notin> L \<and>
              z \<notin> free_ty_env (\<Gamma>,(x:\<tau>')) \<and> \<not> \<Delta> defines z"
          using Hz Hf Hd by auto
        hence "\<Gamma>,(x:\<tau>');\<Delta>,(z:\<star>) \<turnstile> freshen_tmty z (vsubst_tm (TmFreeVar x) i e) : ?\<tau>new"
          using Htyp by auto
        moreover
        have "\<forall>k. vsubst_tmty (TyFreeVar z) k (TmFreeVar x) = (TmFreeVar x)" by auto
        ultimately
        have A3: "\<Gamma>,(x:\<tau>');\<Delta>,(z:\<star>) \<turnstile> vsubst_tm (TmFreeVar x) i ?enew : ?\<tau>new"
          using subst_subst_tmty_swap[of z "TmFreeVar x" i 0 e] by auto
        have A4: "\<not> x free in ?enew" using prems not_free_subst_sty[of x e] by auto
        have "\<Gamma>;\<Delta>,(z:\<star>) \<turnstile> vsubst_tm e' i (freshen_tmty z e) : freshen_ty z \<tau>b"
          using "1.hyps" A1 A2 A3 A4 by blast
        moreover
        have "\<forall>k. vsubst_tmty (TyFreeVar z) k e' = e'"
          using prems by (auto simp add: ty_same_subst_ty)
        ultimately
        have "\<Gamma>;\<Delta>,(z:\<star>) \<turnstile> freshen_tmty z (vsubst_tm e' i e) : freshen_ty z \<tau>b"
          by (auto simp add: subst_subst_tmty_swap)
      }
      thus
        "\<forall>xa. xa \<notin> set (free_tmty ?e_b) \<and> xa \<notin> set (free_ty \<tau>b) \<and>
         xa \<notin> ?L' \<and>
         xa \<notin> free_ty_env \<Gamma> \<and>
         xa \<notin> dom \<Delta> \<longrightarrow>
        \<Gamma>;\<Delta>,(xa:\<star>) \<turnstile> freshen_tmty xa (vsubst_tm e' i e) : freshen_ty xa \<tau>b" by auto
    next
      show "\<Gamma>;\<Delta> \<Turnstile> OK" using prems ty_wf_env by auto
    qed
    thus ?thesis using prems by auto
  next
    case (TmApp e1 e2)
    let ?e1s = "vsubst_tm (TmFreeVar x) i e1"
    let ?e2s = "vsubst_tm (TmFreeVar x) i e2"
    have "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> ?e1s \<cdot> ?e2s : \<tau>" using prems by auto
    then obtain \<tau>1 where H1: "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> ?e1s : \<tau>1 \<rightarrow> \<tau>"
      and H2: "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> ?e2s : \<tau>1" by auto
    { obtain n1 where "size e1 = n1" by auto
      moreover
      hence "n1 < n_y" using prems by auto
      moreover
      have "\<not> x free in e1" using prems by auto
      ultimately
      have "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e1 : \<tau>1 \<rightarrow> \<tau>"
        using H1 "1.hyps" "1.prems" by auto
    }
    moreover
    { obtain n2 where "size e2 = n2" by auto
      moreover
      hence "n2 < n_y" using prems by auto
      moreover
      have "\<not> x free in e2" using prems by auto
      ultimately
      have "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e2 : \<tau>1"
        using H2 "1.hyps" "1.prems" by auto
    }
    ultimately
    show "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_y : \<tau>" using TmApp by auto
  next
    case (TmTapp e \<tau>a)
    let ?es = "vsubst_tm (TmFreeVar x) i e"
    have "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> ?es \<langle>\<tau>a\<rangle> : \<tau>" using prems by auto
    then obtain \<tau>b where H1: "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> ?es : \<forall>.\<tau>b"
      and H2: "vsubst_ty \<tau>a 0 \<tau>b = \<tau>"
      and H3: "\<Delta> \<Turnstile> \<tau>a" using typing_app_ty_elim by auto
    { obtain n1 where "size e = n1" by auto
      moreover
      hence "n1 < n_y" using prems by auto
      moreover
      have "\<not> x free in e" using prems by auto
      ultimately
      have "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e : \<forall>.\<tau>b"
        using H1 "1.hyps" "1.prems" by auto
    }
    thus "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_y : \<tau>" using TmTapp H2 H3 t_tyapp by auto
  next
    case (TmNew e_b)
    let ?es = "vsubst_tm (TmFreeVar x) i e_b"
    have "vsubst_tm (TmFreeVar x) i e_y = TmNew ?es" using TmNew by auto
    hence "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> TmNew ?es : \<tau>" using prems by auto
    then obtain \<tau>_b where H1: "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> ?es : \<tau>_b" and
      H2: "\<tau> = TyRef \<tau>_b" by auto
    { obtain n where "size e_b = n" by auto
      moreover
      hence "n < n_y" using prems by auto
      moreover
      have "\<not> x free in e_b" using prems by (auto simp add: mem_iff)
      ultimately
      have "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_b : \<tau>_b" using H1 "1.hyps" "1.prems" by auto
    }
    thus "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_y : \<tau>" using TmNew H2 by auto
  next
    case (TmAssign e_1 e_2)
    let ?e1s = "vsubst_tm (TmFreeVar x) i e_1"
    let ?e2s = "vsubst_tm (TmFreeVar x) i e_2"
    have "vsubst_tm (TmFreeVar x) i e_y = ?e1s := ?e2s" using TmAssign by auto
    hence "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> ?e1s := ?e2s : \<tau>" using prems by auto
    then obtain \<tau>_b where H1: "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> ?e1s : TyRef \<tau>_b"
      and H2: "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> ?e2s : \<tau>_b" and H3: "\<tau> = TyUnit" by auto
    { obtain n1 where "size e_1 = n1" by auto
      moreover
      hence "n1 < n_y" using prems by auto
      moreover
      have "\<not> x free in e_1" using prems by (auto simp add: mem_iff)
      ultimately
      have "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_1 : TyRef \<tau>_b" using H1 "1.hyps" "1.prems" by auto
    }
    moreover
    { obtain n2 where "size e_2 = n2" by auto
      moreover
      hence "n2 < n_y" using prems by auto
      moreover
      have "\<not> x free in e_2" using prems by (auto simp add: mem_iff)
      ultimately
      have "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_2 : \<tau>_b" using H2 "1.hyps" "1.prems" by auto
    }
    ultimately
    show "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_y : \<tau>" using TmAssign H3 by auto
  next
    case (TmDeref e_b)
    let ?es = "vsubst_tm (TmFreeVar x) i e_b"
    have "vsubst_tm (TmFreeVar x) i e_y = TmDeref ?es" using TmDeref by auto
    hence "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> TmDeref ?es : \<tau>" using prems by auto
    then obtain \<tau>_b where H1: "\<Gamma>,(x:\<tau>');\<Delta> \<turnstile> ?es : TyRef \<tau>_b" and
      H2: "\<tau> = \<tau>_b" by auto
    { obtain n where "size e_b = n" by auto
      moreover
      hence "n < n_y" using prems by auto
      moreover
      have "\<not> x free in e_b" using prems by (auto simp add: mem_iff)
      ultimately
      have "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_b : TyRef \<tau>_b" using H1 "1.hyps" "1.prems" by auto
    }
    thus "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_y : \<tau>" using TmDeref H2 by auto
  next
    case (TmLoc l)
    have "\<Gamma>;\<Delta> \<Turnstile> OK" using prems by (auto simp add: ty_wf_env)
    moreover have "vsubst_tm e' i (TmLoc l) = TmLoc l" by auto
    moreover
    obtain \<tau>_b where H: "\<tau> = TyRef \<tau>_b"  using prems by auto
    have "vsubst_tm (TmFreeVar x) i (TmLoc l) = TmLoc l" by auto
    ultimately
    have "\<Gamma>;\<Delta> \<turnstile> TmLoc l : TyRef \<tau>_b" using prems by auto
    thus "\<Gamma>;\<Delta> \<turnstile> vsubst_tm e' i e_y : \<tau>" using prems by auto
  qed
qed


lemma substitution_ty:
  fixes n :: nat
  assumes "size e = n"
  and "(vsubst_ty_env \<tau>' i \<Gamma>);\<Delta> \<Turnstile> OK"
  and "vsubst_ty_env (TyFreeVar x) i \<Gamma>;\<Delta>,(x:\<star>) \<turnstile>
          vsubst_tmty (TyFreeVar x) i e : vsubst_ty (TyFreeVar x) i \<tau>"
  and "\<not> x free in term e \<and> \<not> x free in type \<tau> \<and> x \<notin> free_ty_env \<Gamma> \<and> x \<notin> dom \<Delta>"
  and "\<Delta> \<Turnstile> \<tau>'"
  shows "vsubst_ty_env \<tau>' i \<Gamma>;\<Delta> \<turnstile> vsubst_tmty \<tau>' i e : vsubst_ty \<tau>' i \<tau>"
using prems proof (induct n arbitrary: e \<tau> i \<tau>' \<Gamma> \<Delta> rule: nat_less_induct)
  case (1 n_y e_y \<tau>)
  let ?\<Gamma>x = "vsubst_ty_env (TyFreeVar x) i \<Gamma>"
  let ?\<Gamma>t = "vsubst_ty_env \<tau>' i \<Gamma>"
  show ?case
  proof (cases e_y)
    case TmUnit
    hence "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> TmUnit : vsubst_ty (TyFreeVar x) i \<tau>"
      using prems by auto
    hence "vsubst_ty (TyFreeVar x) i \<tau> = TyUnit" by auto
    hence "\<tau> = TyUnit" by (cases \<tau>, auto simp add: trivial_case)
    thus ?thesis using prems by auto
  next
    case (TmFreeVar y)
    hence Ht: "vsubst_ty_env (TyFreeVar x) i \<Gamma>;\<Delta>,(x:\<star>) \<turnstile> 
                 TmFreeVar y : vsubst_ty (TyFreeVar x) i \<tau>"
      using prems by auto
    hence "(y\<rhd>vsubst_ty (TyFreeVar x) i \<tau>) \<in> ?\<Gamma>x" by auto
    hence "?\<Gamma>x = ?\<Gamma>x,(y:vsubst_ty (TyFreeVar x) i \<tau>)" by auto
    hence Hx': "?\<Gamma>x = vsubst_ty_env (TyFreeVar x) i (\<Gamma>,(y:\<tau>))"
      by (auto simp add: vsubst_ty_env_def)
    moreover
    have "free_ty_env (\<Gamma>,(y:\<tau>)) = free_ty_env \<Gamma> \<union> set (free_ty \<tau>)"
      using free_ty_env_def by auto
    hence "\<not> x free in env (\<Gamma>,(y:\<tau>))" using prems by auto
    moreover
    hence "\<not> x free in env \<Gamma>" using prems by auto
    ultimately
    have "?\<Gamma>t = vsubst_ty_env \<tau>' i (\<Gamma>,(y:\<tau>))" 
      using subst_subst_equal_env[of x i \<Gamma> "\<Gamma>,(y:\<tau>)"] by auto
    hence "?\<Gamma>t = vsubst_ty_env \<tau>' i \<Gamma>,(y:vsubst_ty \<tau>' i \<tau>)"
      by (auto simp add: vsubst_ty_env_def)
    hence "(y\<rhd>vsubst_ty \<tau>' i \<tau>) \<in> ?\<Gamma>t" by auto
    thus ?thesis using prems by auto
  next
    case (TmVar j)
    hence "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> vsubst_tmty (TyFreeVar x) i (TmVar j) : vsubst_ty (TyFreeVar x) i \<tau>"
      using prems by auto
    hence "?\<Gamma>t;\<Delta>,(x:\<star>) \<turnstile> TmVar j : vsubst_ty (TyFreeVar x) i \<tau>" by auto
    hence False by auto
    thus ?thesis by auto
  next
    case (TmApp e1 e2)
    let ?e1s = "vsubst_tmty (TyFreeVar x) i e1"
    let ?e2s = "vsubst_tmty (TyFreeVar x) i e2"
    have "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?e1s \<cdot> ?e2s : vsubst_ty (TyFreeVar x) i \<tau>"
      using prems by auto
    then obtain \<tau>new where H1: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?e1s : \<tau>new \<rightarrow> vsubst_ty (TyFreeVar x) i \<tau>"
      and H2: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?e2s : \<tau>new" by auto
    hence "\<Delta>,(x:\<star>) \<Turnstile> \<tau>new" using ty_wf_type by auto
    then obtain \<tau>n where Hn: "\<tau>new = vsubst_ty (TyFreeVar x) i \<tau>n"
      and Hfree: "\<not> x free in type \<tau>n" using parametrize_ty[of x _ \<tau>new i] by auto
    { obtain n1 where "size e1 = n1" by auto
      moreover
      hence "n1 < n_y" using prems by auto
      moreover
      have "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?e1s : vsubst_ty (TyFreeVar x) i (\<tau>n \<rightarrow> \<tau>)"
        using H1 Hn by auto
      moreover
      have "\<not> x free in term e1 \<and> x \<notin> set (free_ty (\<tau>n \<rightarrow> \<tau>)) \<and> x \<notin> free_ty_env \<Gamma>
            \<and> x \<notin> Environ.dom \<Delta>" using prems Hfree by auto
      moreover
      have "?\<Gamma>t;\<Delta> \<Turnstile> OK" by assumption
      ultimately
      have "?\<Gamma>t;\<Delta> \<turnstile> vsubst_tmty \<tau>' i e1 : vsubst_ty \<tau>' i (\<tau>n \<rightarrow> \<tau>)"
        using H1 "1.hyps" "1.prems" by blast
    }
    moreover
    { obtain n2 where "size e2 = n2" by auto
      moreover
      hence "n2 < n_y" using prems by auto
      moreover
      have "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?e2s : vsubst_ty (TyFreeVar x) i \<tau>n "
        using H2 Hn by auto
      moreover from prems
      have "\<not> x free in term e2 \<and> x \<notin> set (free_ty \<tau>n) \<and> x \<notin> free_ty_env \<Gamma>
            \<and> x \<notin> Environ.dom \<Delta>" using prems Hfree by auto
      ultimately
      have "?\<Gamma>t;\<Delta> \<turnstile> vsubst_tmty \<tau>' i e2 : vsubst_ty \<tau>' i \<tau>n"
        using H2 "1.hyps" "1.prems" by blast
    }
    ultimately
    show ?thesis using TmApp by auto
  next
    case (TmTapp e \<tau>a)
    let ?es = "vsubst_tmty (TyFreeVar x) i e"
    let ?\<tau>s = "vsubst_ty (TyFreeVar x) i \<tau>a"
    have Ht1: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?es\<langle>?\<tau>s\<rangle> : vsubst_ty (TyFreeVar x) i \<tau>" using prems by auto
    then obtain \<tau>b where H1: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?es : \<forall>.\<tau>b"
      and H2: "vsubst_ty (TyFreeVar x) i \<tau> = vsubst_ty ?\<tau>s 0 \<tau>b"
      and H3: "\<Delta>,(x:\<star>) \<Turnstile> ?\<tau>s"
      using typing_app_ty_elim[of \<Gamma> "\<Delta>,(x:\<star>)" ?es ?\<tau>s "vsubst_ty (TyFreeVar x) i \<tau>"] by auto
    hence "\<Delta>,(x:\<star>) \<Turnstile> vsubst_ty ?\<tau>s 0 \<tau>b" using ty_wf_type Ht1 by auto
    have "\<Delta>,(x:\<star>) \<Turnstile> \<forall>.\<tau>b" using H1 ty_wf_type by auto
    then obtain \<tau>n' where Hn: "vsubst_ty (TyFreeVar x) i \<tau>n' = \<forall>.\<tau>b"
      and  Hfree: "\<not> x free in type \<tau>n'" using parametrize_ty[of x \<Delta> "\<forall>.\<tau>b" i] by auto
    then obtain \<tau>n where Hn2: "\<tau>n' = \<forall>.\<tau>n" by (cases \<tau>n', auto simp add: trivial_case)
    hence H4: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?es : vsubst_ty (TyFreeVar x) i \<tau>n'"
      and H5: "\<forall>.\<tau>b = \<forall>.vsubst_ty (TyFreeVar x) (Suc i) \<tau>n" using H1 Hn by auto
    { obtain n1 where "size e = n1" by auto
      moreover
      hence "n1 < n_y" using prems by auto
      moreover
      have "\<not> x free in term e \<and> x \<notin> set (free_ty \<tau>n') \<and> x \<notin> free_ty_env \<Gamma>
            \<and> x \<notin> Environ.dom \<Delta>" using prems Hfree by auto
      ultimately
      have "?\<Gamma>t;\<Delta> \<turnstile> vsubst_tmty \<tau>' i e : vsubst_ty \<tau>' i \<tau>n'"
        using H4 Hn "1.hyps" "1.prems" by auto
      hence "?\<Gamma>t;\<Delta> \<turnstile> vsubst_tmty \<tau>' i e : \<forall>.vsubst_ty \<tau>' (Suc i) \<tau>n" using Hn2 by auto
    }
    moreover
    have Hta: "\<Delta> \<Turnstile> vsubst_ty \<tau>' i \<tau>a" using H3 subst_var_type_ok[of x \<Delta> i \<tau>a] prems by auto
    ultimately
    have Htfinal: "?\<Gamma>t;\<Delta> \<turnstile> (vsubst_tmty \<tau>' i e) \<langle>vsubst_ty \<tau>' i \<tau>a\<rangle> :
            vsubst_ty (vsubst_ty \<tau>' i \<tau>a) 0 (vsubst_ty \<tau>' (Suc i) \<tau>n)" by auto
    hence Heqt: "vsubst_ty (TyFreeVar x) i \<tau> =
         vsubst_ty (vsubst_ty (TyFreeVar x) i \<tau>a) 0 (vsubst_ty (TyFreeVar x) (Suc i) \<tau>n)"
      using H2 H5 by auto 
    moreover
    {
      have "\<Delta>,(x:\<star>) \<Turnstile> vsubst_ty (TyFreeVar x) i \<tau>" using Ht1 ty_wf_type by auto
      hence "set (free_db_ty (vsubst_ty (TyFreeVar x) i \<tau>)) = {}"
        using ok_no_free_db by auto
      moreover
      have "set (free_db_ty (vsubst_ty (TyFreeVar x) i \<tau>)) =
        set (free_db_ty \<tau>) - {i}"
        using vsubst_ty_free_db_ty by auto
      ultimately
      have "set (free_db_ty \<tau>) \<subseteq> {i}" by auto
    }
    moreover
    {
      have "set (free_db_ty (vsubst_ty (TyFreeVar x) i \<tau>a)) = {}"
        using ok_no_free_db H3 by auto
      moreover
      have "set (free_db_ty (vsubst_ty (TyFreeVar x) i \<tau>a)) =
        set (free_db_ty \<tau>a) - {i}"
        using vsubst_ty_free_db_ty by auto
      ultimately
      have "set (free_db_ty \<tau>a) \<subseteq> {i}" by auto
    }
    moreover
    {
      have "\<Delta>,(x:\<star>) \<Turnstile>
        vsubst_ty (vsubst_ty (TyFreeVar x) i \<tau>a) 0 (vsubst_ty (TyFreeVar x) (Suc i) \<tau>n)"
        using Ht1 Heqt ty_wf_type by auto
      hence "set (free_db_ty
        (vsubst_ty (vsubst_ty (TyFreeVar x) i \<tau>a) 0 (vsubst_ty (TyFreeVar x) (Suc i) \<tau>n)))
        = {}"
        using ok_no_free_db by auto
      moreover
      have "set (free_db_ty (vsubst_ty (TyFreeVar x) i \<tau>a)) = {}"
        using ok_no_free_db prems H3 by auto
      hence "set (free_db_ty
        (vsubst_ty (vsubst_ty (TyFreeVar x) i \<tau>a) 0 (vsubst_ty (TyFreeVar x) (Suc i) \<tau>n)))
        =
        set (free_db_ty ((vsubst_ty (TyFreeVar x) (Suc i) \<tau>n))) - {0}"
        using vsubst_ty_free_db_ty[of "vsubst_ty (TyFreeVar x) i \<tau>a"] by auto 
      moreover
      have "set (free_db_ty ((vsubst_ty (TyFreeVar x) (Suc i) \<tau>n))) =
        set (free_db_ty \<tau>n) - {Suc i}" using vsubst_ty_free_db_ty by auto      
      ultimately
      have "set (free_db_ty \<tau>n) \<subseteq> {0, Suc i}" by auto
    }
    moreover have "set (free_db_ty \<tau>') = {}" using prems ok_no_free_db by auto
    moreover have "x \<notin> set (free_ty \<tau>)" using prems by auto
    moreover have "x \<notin> set (free_ty \<tau>a)" using prems by auto
    moreover have "x \<notin> set (free_ty \<tau>n)" using prems by auto
    ultimately
    have "vsubst_ty \<tau>' i \<tau> = vsubst_ty (vsubst_ty \<tau>' i \<tau>a) 0 (vsubst_ty \<tau>' (Suc i) \<tau>n)"
      using vsubst_equal_sanity[of x i \<tau>a \<tau>n \<tau> \<tau>'] by auto
    thus "?\<Gamma>t;\<Delta> \<turnstile> vsubst_tmty \<tau>' i e_y : vsubst_ty \<tau>' i \<tau>"
      using Htfinal TmTapp by auto
  next
    case (TmNew er)
    let ?es = "vsubst_tmty (TyFreeVar x) i er"
    have "vsubst_tmty (TyFreeVar x) i e_y = TmNew ?es" using TmNew by auto
    hence "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> TmNew ?es : vsubst_ty (TyFreeVar x) i \<tau>" using prems by auto
    then obtain \<tau>r where H1: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?es : vsubst_ty (TyFreeVar x) i \<tau>r" and
      H2: "TyRef \<tau>r = \<tau>" by (cases \<tau>, auto simp add: trivial_case)
    { obtain n where "size er = n" by auto
      moreover
      hence "n < n_y" using prems by auto
      moreover
      from prems have "\<not> x free in term er" using prems by (auto simp add: mem_iff)
      moreover
      from prems have "\<not> x free in type \<tau>r" using prems by (auto simp add: mem_iff)
      moreover
      have "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?es : vsubst_ty (TyFreeVar x) i \<tau>r"
        using H1 by auto
      ultimately
      have "?\<Gamma>t;\<Delta> \<turnstile> vsubst_tmty \<tau>' i er : vsubst_ty \<tau>' i \<tau>r"
        using "1.hyps" "1.prems" by auto
    }
    thus ?thesis using TmNew H2 by auto
  next
    case (TmAssign e1 e2)
    let ?e1s = "vsubst_tmty (TyFreeVar x) i e1"
    let ?e2s = "vsubst_tmty (TyFreeVar x) i e2"
    have "vsubst_tmty (TyFreeVar x) i e_y = ?e1s := ?e2s" using TmAssign by auto
    hence Ht: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?e1s := ?e2s : vsubst_ty (TyFreeVar x) i \<tau>" using prems by auto
    hence H3: "\<tau> = TyUnit" by (cases \<tau>, auto simp add: trivial_case)
    from Ht obtain \<tau>r' where H1: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?e1s : TyRef \<tau>r'"
      and H2: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?e2s : \<tau>r'" by auto
    hence "\<Delta>,(x:\<star>) \<Turnstile> \<tau>r'" using ty_wf_type by auto
    then obtain \<tau>r where "\<tau>r' = vsubst_ty (TyFreeVar x) i \<tau>r" and "\<not> x free in type \<tau>r"
      using parametrize_ty[of x \<Delta> \<tau>r'] by auto
    hence H1': "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?e1s : vsubst_ty (TyFreeVar x) i (TyRef \<tau>r)"
      and H2': "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?e2s : vsubst_ty (TyFreeVar x) i \<tau>r"
      using H1 H2 by auto
    { obtain n1 where "size e1 = n1" by auto
      moreover
      hence "n1 < n_y" using prems by auto
      moreover
      have "\<not> x free in term e1" using prems by (auto simp add: mem_iff)
      moreover
      have "\<not> x free in type (TyRef \<tau>r)" using prems by (auto simp add: mem_iff)
      ultimately
      have "?\<Gamma>t;\<Delta> \<turnstile> vsubst_tmty \<tau>' i e1 : vsubst_ty \<tau>' i (TyRef \<tau>r)"
        using H1' "1.hyps" "1.prems" by blast
    }
    moreover
    { obtain n2 where "size e2 = n2" by auto
      moreover
      hence "n2 < n_y" using prems by auto
      moreover
      have "\<not> x free in term e2" using prems by (auto simp add: mem_iff)
      moreover
      have "\<not> x free in type \<tau>r" using prems by (auto simp add: mem_iff)
      ultimately
      have "?\<Gamma>t;\<Delta> \<turnstile> vsubst_tmty \<tau>' i e2 : vsubst_ty \<tau>' i \<tau>r"
        using H2' "1.hyps" "1.prems" by auto
    }
    ultimately
    show ?thesis using TmAssign H3 by auto
  next
    case (TmDeref er)
    let ?es = "vsubst_tmty (TyFreeVar x) i er"
    have "vsubst_tmty (TyFreeVar x) i e_y = TmDeref ?es" using TmDeref by auto
    hence "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> TmDeref ?es : vsubst_ty (TyFreeVar x) i \<tau>" using prems by auto
    then obtain \<tau>r' where H1: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?es : TyRef \<tau>r'" and
      H2: "\<tau>r' = vsubst_ty (TyFreeVar x) i \<tau>" by auto
    hence "\<Delta>,(x:\<star>) \<Turnstile> \<tau>r'" using ty_wf_type by auto
    then obtain \<tau>r where Hr: "\<tau>r' = vsubst_ty (TyFreeVar x) i \<tau>r" and Hfr: "\<not> x free in type \<tau>r"
      using parametrize_ty[of x \<Delta> \<tau>r'] by auto
    hence Heq: "\<tau>r = \<tau>" using H2 Hfr subst_subst_equal_tyty[of x i \<tau>r \<tau>] prems by blast
    have H1': "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> ?es : vsubst_ty (TyFreeVar x) i (TyRef \<tau>r)"
      using H1 Hr by auto
    { obtain n where "size er = n" by auto
      moreover
      hence "n < n_y" using prems by auto
      moreover
      have "\<not> x free in term er" using prems by (auto simp add: mem_iff)
      moreover
      have "\<not> x free in type (TyRef \<tau>r)" using prems by (auto simp add: mem_iff)
      ultimately
      have "?\<Gamma>t;\<Delta> \<turnstile> vsubst_tmty \<tau>' i er : vsubst_ty \<tau>' i (TyRef \<tau>r)"
        using H1' "1.hyps" "1.prems" by blast
    }
    thus ?thesis using TmDeref Heq H2 by auto
  next
    case (TmLoc l)
    hence Ht: "vsubst_ty_env (TyFreeVar x) i \<Gamma>;\<Delta>,(x:\<star>) \<turnstile> TmLoc l : vsubst_ty (TyFreeVar x) i \<tau>"
      using prems by auto
    then obtain \<tau>ins where Heq: "\<tau> = TyRef \<tau>ins" by (cases \<tau>, auto simp add: trivial_case)
    hence "(l\<rhd>vsubst_ty (TyFreeVar x) i \<tau>ins) \<in> ?\<Gamma>x" using Ht by auto
    hence "?\<Gamma>x = ?\<Gamma>x,(l:vsubst_ty (TyFreeVar x) i \<tau>ins)" by auto
    hence Hx': "?\<Gamma>x = vsubst_ty_env (TyFreeVar x) i (\<Gamma>,(l:\<tau>ins))" by (auto simp add: vsubst_ty_env_def)
    moreover
    have "free_ty_env (\<Gamma>,(l:\<tau>ins)) = free_ty_env \<Gamma> \<union> set (free_ty \<tau>ins)"
      using free_ty_env_def by auto
    hence Hx'': "\<not> x free in env \<Gamma>" and Hx''': "\<not> x free in env (\<Gamma>,(l:\<tau>ins))"
      using prems by auto
    moreover
    ultimately
    have "?\<Gamma>t = vsubst_ty_env \<tau>' i (\<Gamma>,(l:\<tau>ins))"
      using subst_subst_equal_env[of x i \<Gamma> "\<Gamma>,(l:\<tau>ins)"] by auto
    hence "?\<Gamma>t = vsubst_ty_env \<tau>' i \<Gamma>,(l:vsubst_ty \<tau>' i \<tau>ins)" by (auto simp add: vsubst_ty_env_def)
    hence "(l\<rhd>vsubst_ty \<tau>' i \<tau>ins) \<in> ?\<Gamma>t" by auto
    thus ?thesis using prems by auto
  next
    case (TmProd e)
    have Ht: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> \<Lambda>[*]. vsubst_tmty (TyFreeVar x) (Suc i) e : vsubst_ty (TyFreeVar x) i \<tau>"
      using prems by auto
    then obtain \<tau>b where Heqb: "\<tau> = \<forall>.\<tau>b" by (cases \<tau>, auto simp add: trivial_case)
    hence Ht: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> \<Lambda>[*]. vsubst_tmty (TyFreeVar x) (Suc i) e : \<forall>. vsubst_ty (TyFreeVar x) (Suc i) \<tau>b" using Ht by auto
    thus ?thesis proof
      fix L \<tau>r
      assume "?\<Gamma>x;\<Delta>,(x:\<star>) \<Turnstile> OK"
        and "finite L"
        and Hv: "value (vsubst_tmty (TyFreeVar x) (Suc i) e)"
        and Ht: "\<forall>a. a \<notin> set (free_tmty (vsubst_tmty (TyFreeVar x) (Suc i) e)) \<and>
                     a \<notin> set (free_ty \<tau>r) \<and> a \<notin> L \<and> a \<notin> free_ty_env ?\<Gamma>x \<and> a \<notin> dom (\<Delta>,(x:\<star>)) \<longrightarrow>
                      ?\<Gamma>x;\<Delta>,(x:\<star>),(a:\<star>) \<turnstile> vsubst_tmty (TyFreeVar a) 0
                      (vsubst_tmty (TyFreeVar x) (Suc i) e) : vsubst_ty (TyFreeVar a) 0 \<tau>r"
        and "\<forall>.vsubst_ty (TyFreeVar x) (Suc i) \<tau>b = \<forall>.\<tau>r"
      hence Heq: "\<tau>r = vsubst_ty (TyFreeVar x) (Suc i) \<tau>b" by auto
      have "?\<Gamma>t;\<Delta> \<turnstile> \<Lambda>[*]. vsubst_tmty \<tau>' (Suc i) e  : \<forall>.(vsubst_ty \<tau>' (Suc i) \<tau>b)" proof
        show "?\<Gamma>t;\<Delta> \<Turnstile> OK" using prems by auto
      next
        show "value (vsubst_tmty \<tau>' (Suc i) e)" using Hv by (induct e arbitrary: i, auto)
      next
        show "finite ({x} \<union> set (free_ty \<tau>r) \<union> L \<union> set (free_tmty (vsubst_tmty (TyFreeVar x) (Suc i) e)))" by auto
      next
        let ?\<Gamma>i = "convert_ty_env (Suc i) i \<Gamma>"
        have Hdok: "\<Delta>,(x:\<star>) \<Turnstile> TY" using prems wf_env_wf_env_ty by auto
        hence "\<Delta>,(x:\<star>) \<Turnstile> TyFreeVar x" using wf_tvar by auto
        hence Hgisx: "?\<Gamma>x = vsubst_ty_env (TyFreeVar x) (Suc i) ?\<Gamma>i"
          using subst_convert_env[of _ "\<Delta>,(x:\<star>)" x i \<Gamma> "TyFreeVar x" "Suc i"] prems by auto
        have "\<Delta>,(x:\<star>) \<Turnstile> \<tau>'" using ok_weakening_ty Hdok prems by auto
        hence Hgist: "?\<Gamma>t = vsubst_ty_env \<tau>' (Suc i) ?\<Gamma>i"
          using subst_convert_env[of _ "\<Delta>,(x:\<star>)" x i \<Gamma> \<tau>' "Suc i"] prems by auto
        {
          fix a
          assume "a \<notin> set (free_tmty (vsubst_tmty \<tau>' (Suc i) e))"
            and "a \<notin> set (free_ty (vsubst_ty \<tau>' (Suc i) \<tau>b))"
            and Hfree: "a \<notin> {x} \<union> set (free_ty \<tau>r) \<union> L \<union>  set (free_tmty (vsubst_tmty (TyFreeVar x) (Suc i) e))"
            and Hfree1: "a \<notin> free_ty_env ?\<Gamma>t"
            and Hfree2: "a \<notin> Environ.dom \<Delta>"
          obtain n where "size (vsubst_tmty (TyFreeVar x) (Suc i) e) = n" by auto
          moreover
          hence "n < n_y" using prems by auto
          moreover
          hence "\<not> x free in term e" using prems by auto
          hence "\<not> x free in term (freshen_tmty a e)" using not_free_subst_tmty prems by auto
          moreover
          hence "\<not> x free in type \<tau>b" using prems by auto
          hence "\<not> x free in type (freshen_ty a \<tau>b)" using not_free_subst_ty prems by auto
          moreover
          have "\<not> \<Delta>,(a:\<star>) defines x" using prems by (auto simp add: dom_def)
          moreover
          have "x \<notin> free_ty_env ?\<Gamma>i" using prems not_free_convert_env by auto
          moreover
          have "\<Delta>,(a:\<star>) \<Turnstile> \<tau>'" using prems ok_weakening_ty by auto
          moreover
          {
            have "\<not> \<Delta>,(x:\<star>) defines a" using prems by (auto simp add: dom_def)
            moreover
            have "\<not> a free in env \<Gamma>" using inv_not_free_subst_env[of a \<tau>' i \<Gamma>] prems by auto
            hence "\<not> a free in env ?\<Gamma>x" using not_free_subst_env[of a \<Gamma> "TyFreeVar x" i] prems by auto
            ultimately
            have "?\<Gamma>x;\<Delta>,(x:\<star>),(a:\<star>) \<turnstile> freshen_tmty a (vsubst_tmty (TyFreeVar x) (Suc i) e) :
              freshen_ty a (vsubst_ty (TyFreeVar x) (Suc i) \<tau>b)"
              using Ht Hfree Hfree1 Hfree2 Heq by auto
            moreover
            have "\<Delta>,(a:\<star>),(x:\<star>) = \<Delta>,(x:\<star>),(a:\<star>)" by auto
            moreover
            have "freshen_tmty a (vsubst_tmty (TyFreeVar x) (Suc i) e)
              = vsubst_tmty (TyFreeVar x) (Suc i) (freshen_tmty a e)"
              using subst_subst_tyty_swap[of 0 "Suc i"] by auto
            moreover
            have "freshen_ty a (vsubst_ty (TyFreeVar x) (Suc i) \<tau>b) =
                  vsubst_ty (TyFreeVar x) (Suc i) (freshen_ty a \<tau>b)"
              using subst_subst_ty_swap[of 0 "Suc i"] by auto
            ultimately
            have "?\<Gamma>x;\<Delta>,(a:\<star>),(x:\<star>) \<turnstile>
                    vsubst_tmty (TyFreeVar x) (Suc i) (freshen_tmty a e) :
                      vsubst_ty (TyFreeVar x) (Suc i) (freshen_ty a \<tau>b)"
              by auto
            hence "vsubst_ty_env (TyFreeVar x) (Suc i) ?\<Gamma>i;\<Delta>,(a:\<star>),(x:\<star>) \<turnstile>
                            vsubst_tmty (TyFreeVar x) (Suc i) (freshen_tmty a e) :
                            vsubst_ty (TyFreeVar x) (Suc i) (freshen_ty a \<tau>b)"
              using Hgisx by auto
          }
          moreover
          have "vsubst_ty_env \<tau>' (Suc i) ?\<Gamma>i;\<Delta> \<Turnstile> OK" using Hgist prems by auto
          hence "vsubst_ty_env \<tau>' (Suc i) ?\<Gamma>i;\<Delta>,(a:\<star>) \<Turnstile> OK" using ok_weakening_tyenv prems by auto
          ultimately
          have "vsubst_ty_env \<tau>' (Suc i) ?\<Gamma>i;\<Delta>,(a:\<star>) \<turnstile> vsubst_tmty \<tau>' (Suc i)
            (freshen_tmty a e) : vsubst_ty \<tau>' (Suc i) (freshen_ty a \<tau>b)"
            using "1.hyps" by auto
          moreover
          have Hst': "\<forall>k. vsubst_ty (TyFreeVar a) k \<tau>' = \<tau>'"
            using no_free_db_vars_same_subst_ty ok_no_free_db prems by auto
          hence "freshen_tmty a (vsubst_tmty \<tau>' (Suc i) e) =
            vsubst_tmty \<tau>' (Suc i) (freshen_tmty a e)"
            using subst_subst_tyty_swap[of "Suc i" 0 a \<tau>' e] by auto
          moreover
          have "freshen_ty a (vsubst_ty \<tau>' (Suc i) \<tau>b) =
            vsubst_ty \<tau>' (Suc i) (freshen_ty a \<tau>b)"
            using  Hst' subst_subst_ty_swap[of 0 "Suc i"] by auto
          moreover
          ultimately
          have "vsubst_ty_env \<tau>' (Suc i) ?\<Gamma>i;\<Delta>,(a:\<star>) \<turnstile> freshen_tmty a (vsubst_tmty \<tau>' (Suc i) e) :
                              freshen_ty a (vsubst_ty \<tau>' (Suc i) \<tau>b)"
            by auto
          hence "vsubst_ty_env \<tau>' i \<Gamma>;\<Delta>,(a:\<star>) \<turnstile> freshen_tmty a (vsubst_tmty \<tau>' (Suc i) e) :
                              freshen_ty a (vsubst_ty \<tau>' (Suc i) \<tau>b)"
            using Hgist by auto
        }
        thus "\<forall>a. a \<notin> set (free_tmty (vsubst_tmty \<tau>' (Suc i) e)) \<and>
          a \<notin> set (free_ty (vsubst_ty \<tau>' (Suc i) \<tau>b)) \<and>
          a \<notin> {x} \<union> set (free_ty \<tau>r) \<union> L \<union>  set (free_tmty (vsubst_tmty (TyFreeVar x) (Suc i) e))
          \<and> a \<notin> free_ty_env ?\<Gamma>t \<and> a \<notin> Environ.dom \<Delta> \<longrightarrow>
          vsubst_ty_env \<tau>' i \<Gamma>;\<Delta>,(a:\<star>) \<turnstile> freshen_tmty a
          (vsubst_tmty \<tau>' (Suc i) e) : freshen_ty a (vsubst_ty \<tau>' (Suc i) \<tau>b)" by auto
      qed
      thus ?thesis using TmProd Heqb by auto
    qed
  next
    case (TmAbs \<tau>a e)
    have Ht: "?\<Gamma>x;\<Delta>,(x:\<star>) \<turnstile> \<lambda>[vsubst_ty (TyFreeVar x) i \<tau>a]. vsubst_tmty (TyFreeVar x) i e
                          : vsubst_ty (TyFreeVar x) i \<tau>"
      using prems by auto
    from Ht show ?thesis proof
      fix L \<tau>r'
      assume "?\<Gamma>x;\<Delta>,(x:\<star>) \<Turnstile> OK"
        and "finite L"
        and "\<Delta>,(x:\<star>) \<Turnstile> vsubst_ty (TyFreeVar x) i \<tau>a"
        and Ht: "\<forall>z. z \<notin> set (free_tm (vsubst_tmty (TyFreeVar x) i e)) \<and>
                 z \<notin> L \<and> z \<notin> Environ.dom ?\<Gamma>x \<longrightarrow>
                 ?\<Gamma>x,(z:vsubst_ty (TyFreeVar x) i \<tau>a);\<Delta>,(x:\<star>) \<turnstile> vsubst_tm (TmFreeVar z) 0
                                         (vsubst_tmty (TyFreeVar x) i e) : \<tau>r'"
        and Heq: "vsubst_ty (TyFreeVar x) i \<tau> = vsubst_ty (TyFreeVar x) i \<tau>a \<rightarrow> \<tau>r'"
      hence "\<Delta>,(x:\<star>) \<Turnstile> vsubst_ty (TyFreeVar x) i \<tau>a \<rightarrow> \<tau>r'" using prems ty_wf_type by auto
      hence "\<Delta>,(x:\<star>) \<Turnstile> \<tau>r'" by auto
      then obtain \<tau>r where Htr: "\<tau>r' = vsubst_ty (TyFreeVar x) i \<tau>r" and Hfx: "\<not> x free in type \<tau>r"
        using parametrize_ty[of _ \<Delta> \<tau>r'] by blast
      hence "vsubst_ty (TyFreeVar x) i \<tau> = vsubst_ty (TyFreeVar x) i (\<tau>a \<rightarrow> \<tau>r)" using Heq by auto
      moreover
      hence "\<not> x free in term (\<lambda>[\<tau>a]. e)" using prems by auto
      hence "\<not> x free in type \<tau>a" by auto
      hence "\<not> x free in type (\<tau>a \<rightarrow> \<tau>r)" using Hfx by auto
      ultimately
      have Hteq: "\<tau> = \<tau>a \<rightarrow> \<tau>r" using Heq subst_subst_equal_tyty[of x i \<tau> "\<tau>a\<rightarrow>\<tau>r"] prems by auto
      let ?L' = "set (free_tm (vsubst_tmty (TyFreeVar x) i e)) \<union> L \<union> dom ?\<Gamma>x"
      have "?\<Gamma>t;\<Delta> \<turnstile> \<lambda>[vsubst_ty \<tau>' i \<tau>a]. vsubst_tmty \<tau>' i e : (vsubst_ty \<tau>' i \<tau>a) \<rightarrow> (vsubst_ty \<tau>' i \<tau>r)"
      proof
        show "?\<Gamma>t;\<Delta> \<Turnstile> OK" by assumption
      next
        have "finite (dom ?\<Gamma>x)" using wf_env_fin prems by auto
        thus "finite ?L'" using prems by auto
      next
        have "x \<notin> set (free_ty \<tau>a)" using prems by auto
        thus "\<Delta> \<Turnstile> vsubst_ty \<tau>' i \<tau>a" using subst_var_type_ok[of x \<Delta> i \<tau>a \<tau>'] prems by auto
      next
        {
          fix z
          assume Hz: "z \<notin> set (free_tm (vsubst_tmty \<tau>' i e))"
            and Hz1: "z \<notin> ?L'"
            and Hz2: "z \<notin> dom ?\<Gamma>t"
          obtain n where "size (vsubst_tm (TmFreeVar z) 0 e) = n" by auto
          moreover
          hence "n < n_y" using prems by auto
          moreover
          have "\<not> x free in term e" using prems by auto
          hence "\<not> x free in term (freshen_tm z e)" using not_free_subst_tm by auto
          moreover
          have "\<not> x free in type \<tau>r" using prems by auto
          moreover
          have "\<Delta> \<Turnstile> \<tau>'" by assumption
          moreover
          have "free_ty_env (\<Gamma>,(z:\<tau>a)) = free_ty_env \<Gamma> \<union> set (free_ty \<tau>a)"
            by (auto simp add: free_ty_env_def)
          hence "x \<notin> free_ty_env (\<Gamma>,(z:\<tau>a))" using prems by auto
          moreover
          have "x \<notin> Environ.dom \<Delta>" using prems by auto
          moreover
          {
            have "z \<notin> set (free_tm (vsubst_tmty (TyFreeVar x) i e)) \<and> z \<notin> L \<and> z \<notin> dom ?\<Gamma>x"
              using Hz Hz1 Hz2 by auto
            hence "?\<Gamma>x,(z:vsubst_ty (TyFreeVar x) i \<tau>a);\<Delta>,(x:\<star>) \<turnstile>
                      freshen_tm z (vsubst_tmty (TyFreeVar x) i e) :
                      vsubst_ty (TyFreeVar x) i \<tau>r"
              using Htr Ht by auto
            moreover
            have "vsubst_tmty (TyFreeVar x) i (freshen_tm z e) =
                   freshen_tm z (vsubst_tmty (TyFreeVar x) i e)"
              using subst_subst_tmty_swap[of _ _ 0 i] by auto
            ultimately
            have "?\<Gamma>x,(z:vsubst_ty (TyFreeVar x) i \<tau>a);\<Delta>,(x:\<star>) \<turnstile>
                      vsubst_tmty (TyFreeVar x) i (freshen_tm z e) :
                      vsubst_ty (TyFreeVar x) i \<tau>r" by auto
            moreover
            have "vsubst_ty_env (TyFreeVar x) i (\<Gamma>,(z:\<tau>a)) =
              vsubst_ty_env (TyFreeVar x) i \<Gamma>,(z:vsubst_ty (TyFreeVar x) i \<tau>a)"
              by (auto simp add: vsubst_ty_env_def)
            hence "?\<Gamma>x,(z:vsubst_ty (TyFreeVar x) i \<tau>a) = vsubst_ty_env (TyFreeVar x) i (\<Gamma>,(z:\<tau>a))"
              by auto
            ultimately
            have "vsubst_ty_env (TyFreeVar x) i (\<Gamma>,(z:\<tau>a));\<Delta>,(x:\<star>) \<turnstile>
              vsubst_tmty (TyFreeVar x) i (freshen_tm z e) : vsubst_ty (TyFreeVar x) i \<tau>r"
              by auto
          }
          moreover
          {
            have H:"vsubst_ty_env \<tau>' i (\<Gamma>,(z:\<tau>a)) = (vsubst_ty_env \<tau>' i \<Gamma>),(z:vsubst_ty \<tau>' i \<tau>a)"
              using vsubst_ty_env_def by auto
            have "?\<Gamma>t;\<Delta> \<Turnstile> OK" using prems ty_wf_env by auto
            moreover
            have "\<Delta>,(x:\<star>) \<Turnstile> vsubst_ty (TyFreeVar x) i \<tau>a" using prems by auto
            have "\<Delta> \<Turnstile> vsubst_ty \<tau>' i \<tau>a" using subst_var_type_ok[of x \<Delta> i] prems by auto
            moreover
            have "\<not> ?\<Gamma>t defines z" using prems by auto
            ultimately
            have "?\<Gamma>t,(z:vsubst_ty \<tau>' i \<tau>a);\<Delta> \<Turnstile> OK" using wf_env_weakening by auto
            hence "vsubst_ty_env \<tau>' i (\<Gamma>,(z:\<tau>a));\<Delta> \<Turnstile> OK" using H by auto
          }
          moreover
          have "\<not> \<Delta> defines x" using prems by auto
          ultimately
          have "vsubst_ty_env \<tau>' i (\<Gamma>,(z:\<tau>a));\<Delta> \<turnstile>
                  vsubst_tmty \<tau>' i (freshen_tm z e) : vsubst_ty \<tau>' i \<tau>r"
            using "1.hyps" by auto
          moreover
          have "vsubst_ty_env \<tau>' i (\<Gamma>,(z:\<tau>a)) = vsubst_ty_env \<tau>' i \<Gamma>,(z:vsubst_ty \<tau>' i \<tau>a)"
            by (auto simp add: vsubst_ty_env_def)
          ultimately
          have "?\<Gamma>t,(z: vsubst_ty \<tau>' i \<tau>a);\<Delta> \<turnstile> vsubst_tmty \<tau>' i (freshen_tm z e) : vsubst_ty \<tau>' i \<tau>r"
             by auto
          hence "?\<Gamma>t,(z:vsubst_ty \<tau>' i \<tau>a);\<Delta> \<turnstile> freshen_tm z (vsubst_tmty \<tau>' i e) : vsubst_ty \<tau>' i \<tau>r"
            using subst_subst_tytm_swap by auto
        }
        thus "\<forall>x. x \<notin> set (free_tm (vsubst_tmty \<tau>' i e)) \<and> x \<notin> ?L' \<and> x \<notin> Environ.dom ?\<Gamma>t \<longrightarrow>
        ?\<Gamma>t,(x:vsubst_ty \<tau>' i \<tau>a);\<Delta> \<turnstile> freshen_tm x (vsubst_tmty \<tau>' i e) : vsubst_ty \<tau>' i \<tau>r" by auto
      qed
      thus ?thesis using prems Hteq by auto
    qed
  qed
qed

constdefs
  storeTyping :: "store \<Rightarrow> tm_env \<Rightarrow> ty_env \<Rightarrow> bool"   ("\<Turnstile> _:_;_ ")
  "storeTyping S \<Gamma> \<Delta> \<equiv> S \<Turnstile> Store \<and> (\<forall>x \<tau>. (x\<rhd>\<tau>) \<in> \<Gamma> \<longrightarrow> (\<exists>v. (x\<mapsto>v) \<in> S \<and> \<Gamma>;\<Delta> \<turnstile> v : \<tau>))"

lemma store_ty_store:
  assumes "\<Turnstile> S : \<Gamma>;\<Delta>"
  shows "S \<Turnstile> Store"
using prems by (auto simp add: storeTyping_def)

lemma store_ty_finite:
  assumes "\<Turnstile> S : \<Gamma>;\<Delta>"
  shows "finite S"
using prems by (auto simp add: storeTyping_def wf_store_def)

lemma st_ty_update:
  assumes "\<Turnstile> S : \<Gamma>;\<Delta>"
  and "\<Gamma>;\<Delta> \<turnstile> TmFreeVar z : \<tau>"
  and "\<Gamma>;\<Delta> \<turnstile> v : \<tau>"
  and "value v"
  shows "\<Turnstile> update S z v : \<Gamma>;\<Delta>"
proof (auto simp add: storeTyping_def)
  fix xa \<tau>a
  assume "xa\<rhd>\<tau>a \<in> \<Gamma>"
  show "\<exists>va. (xa\<mapsto>va) \<in> update S z v \<and> \<Gamma>;\<Delta> \<turnstile> va : \<tau>a" proof (cases "z = xa")
    case True
    hence "(xa\<mapsto>v) \<in> update S z v" using prems by (auto simp add: update_def)
    moreover
    have "\<tau> = \<tau>a" using prems uniq_typing_in_env by auto
    ultimately
    show ?thesis using prems by auto
  next
    case False show ?thesis using prems by (auto simp add: update_def storeTyping_def)
  qed
next
  have "S \<Turnstile> Store" using prems store_ty_store by auto
  thus "update S z v \<Turnstile> Store" using prems store_update_ok by auto
qed

lemma store_dom_in:
  assumes "\<Turnstile> S : \<Gamma>;\<Delta>"
  and "\<Gamma> defines z"
  shows "S defines z"
using prems proof -
  obtain b where "(z,b) \<in> \<Gamma>" using prems by (auto simp add: dom_def)
  show ?thesis proof (cases b)
    fix \<tau>
    assume "b = Term \<tau>"
    from storeTyping_def obtain v where "z\<mapsto>v \<in> S" using prems by blast
    thus "S defines z" using prems by (auto simp add: dom_def)
  qed
qed

lemma store_dom_not_in:
  assumes "\<Turnstile> S : \<Gamma>;\<Delta>"
  and "\<not> S defines z"
  shows "\<not> \<Gamma> defines z"
using prems by (auto simp add: store_dom_in)

lemma store_typing_elim:
  assumes "\<Turnstile> S : \<Gamma>;\<Delta>"
  and "(z\<mapsto>v) \<in> S"
  and "(z\<rhd>\<tau>) \<in> \<Gamma>"
  shows "\<Gamma>;\<Delta> \<turnstile> v : \<tau>"
proof -
  from storeTyping_def[of S \<Gamma> \<Delta>] prems obtain v' 
    where H: "(z\<mapsto>v') \<in> S \<and> \<Gamma>;\<Delta> \<turnstile> v' : \<tau>" 
    and "S \<Turnstile> Store" 
    using prems by auto
  hence "v = v'" using prems wf_store_def by auto
  thus "\<Gamma>;\<Delta> \<turnstile> v : \<tau>" using H by auto
qed

(* move following lemma to semantics *)
lemma wf_store_weakening:
  assumes "S \<Turnstile> Store"
  and "\<not> S defines z"
  and "value v"
  shows "S,(z\<mapsto>v) \<Turnstile> Store"
using prems by (auto simp add: dom_def wf_store_def)

lemma store_typing_cons:
  assumes "\<Turnstile> S : \<Gamma>;\<Delta>"
  and "\<Gamma>;\<Delta> \<turnstile> e : \<tau>"
  and "value e"
  and "\<not> S defines z"
  shows "\<Turnstile> S,(z\<mapsto>e) : \<Gamma>,(z:\<tau>);\<Delta>"
using prems proof (unfold storeTyping_def)
  assume "S \<Turnstile> Store \<and> (\<forall>x \<tau>. x\<rhd>\<tau> \<in> \<Gamma> \<longrightarrow> (\<exists>v. x\<mapsto>v \<in> S \<and> \<Gamma>;\<Delta> \<turnstile> v : \<tau>))"
    and "\<Gamma>;\<Delta> \<turnstile> e : \<tau>"
    and "value e"
    and "z \<notin> dom S"
  have "S \<Turnstile> Store" using prems by auto
  hence "S,(z\<mapsto>e) \<Turnstile> Store" using prems by (auto simp add: wf_store_weakening)
  moreover
  {
    fix xa \<tau>a
    assume "xa\<rhd>\<tau>a \<in> \<Gamma>,(z:\<tau>)"
    have "(\<exists>v. xa\<mapsto>v \<in> S,(z\<mapsto>e) \<and> \<Gamma>,(z:\<tau>);\<Delta> \<turnstile> v : \<tau>a)" proof (cases "z=xa")
      case True
      have "xa\<mapsto>e \<in> S,(z\<mapsto>e)" using prems by auto
      moreover
      {
        have "\<Gamma>;\<Delta> \<Turnstile> OK" using prems ty_wf_env by auto
        moreover have "\<not> \<Gamma> defines z" using prems store_dom_not_in by auto
        moreover have "\<Delta> \<Turnstile> \<tau>" using prems by (auto simp add: ty_wf_type)
        ultimately have Hgok: "\<Gamma>,(z:\<tau>);\<Delta> \<Turnstile> OK" by (auto simp add: wf_env_weakening)
        moreover have "xa\<rhd>\<tau> \<in> \<Gamma>,(z:\<tau>)" using prems by auto
        ultimately have "\<tau> = \<tau>a" using prems uniq_typing_in_env[of "\<Gamma>,(z:\<tau>)" _ xa \<tau> \<tau>a] by auto
        hence "\<Gamma>;\<Delta> \<turnstile> e : \<tau>a" using prems by auto
        hence "\<Gamma>,(z:\<tau>);\<Delta> \<turnstile> e : \<tau>a" using prems weakening_tm[of _ _ _ _ "{z\<rhd>\<tau>}"] Hgok by auto
      }
      ultimately
      have  "(xa\<mapsto>e \<in> S,(z\<mapsto>e) \<and> \<Gamma>,(z:\<tau>);\<Delta> \<turnstile> e : \<tau>a)" using prems by auto
      thus "(\<exists>v. xa\<mapsto>v \<in> S,(z\<mapsto>e) \<and> \<Gamma>,(z:\<tau>);\<Delta> \<turnstile> v : \<tau>a)" by auto
    next
      case False
      have "xa\<rhd>\<tau>a \<in> \<Gamma>" using prems by auto
      then obtain v where "xa\<mapsto>v \<in> S \<and> \<Gamma>;\<Delta> \<turnstile> v : \<tau>a" using prems by blast
      hence "xa\<mapsto>v \<in> S,(z\<mapsto>e)" by auto
      moreover
      {
        have "\<Gamma>;\<Delta> \<Turnstile> OK" using prems ty_wf_env by auto
        moreover have "\<not> \<Gamma> defines z" using prems store_dom_not_in by auto
        moreover have "\<Delta> \<Turnstile> \<tau>" using prems by (auto simp add: ty_wf_type)
        ultimately have "\<Gamma>,(z:\<tau>);\<Delta> \<Turnstile> OK" using prems by (auto simp add: wf_env_weakening)
        hence  "\<Gamma>,(z:\<tau>);\<Delta> \<turnstile> v : \<tau>a" using prems weakening_tm[of _ _ _ _ "{z\<rhd>\<tau>}"] by auto
      }
      ultimately show ?thesis by blast
    qed
  }
  hence "(\<forall>x \<tau>'. x\<rhd>\<tau>' \<in> \<Gamma>,(z:\<tau>) \<longrightarrow> (\<exists>v. x\<mapsto>v \<in> S,(z\<mapsto>e) \<and> \<Gamma>,(z:\<tau>);\<Delta> \<turnstile> v : \<tau>'))" by blast
  ultimately
  show "S,(z\<mapsto>e) \<Turnstile> Store \<and> (\<forall>x \<tau>'. x\<rhd>\<tau>' \<in> \<Gamma>,(z:\<tau>) \<longrightarrow> (\<exists>v. x\<mapsto>v \<in> S,(z\<mapsto>e) \<and> \<Gamma>,(z:\<tau>);\<Delta> \<turnstile> v : \<tau>'))"
    by auto
qed

(* unused 
lemma store_typing_weakening:
  assumes "\<Turnstile> S:\<Gamma>;\<Delta>"
  and "\<Gamma>;\<Delta> \<Turnstile> OK"
  and "\<not> \<Delta> defines a"
  shows "\<Turnstile> S:\<Gamma>;\<Delta>,(a:\<star>)"
using prems proof (unfold storeTyping_def, auto simp add: ok_weakening_tyenv)
  fix x \<tau>
  assume "\<Turnstile> S:\<Gamma>;\<Delta>"
    and "S \<Turnstile> Store"
    and "\<forall>x \<tau>. (x, Term \<tau>) \<in> \<Gamma> \<longrightarrow> (\<exists>v. x\<mapsto>v \<in> S \<and> \<Gamma>;\<Delta> \<turnstile> v : \<tau>)"
    and "(x, Term \<tau>) \<in> \<Gamma>"
  then obtain v where Hv: "x\<mapsto>v \<in> S \<and> \<Gamma>;\<Delta> \<turnstile> v : \<tau>" by auto
  moreover
  have "\<Gamma>;\<Delta>,(a:\<star>) \<Turnstile> OK" using prems ok_weakening_tyenv by auto
  ultimately
  have "\<Gamma>;\<Delta>,(a:\<star>) \<turnstile> v : \<tau>" using prems weakening_ty[of _ _ _ _ "{a\<rhd>\<star>}"] by auto
  thus "\<exists>v. x\<mapsto>v \<in> S \<and> \<Gamma>;\<Delta>,(a:\<star>) \<turnstile> v : \<tau>" using Hv exI[of _ v] by auto
qed
*)

theorem preservation:
  assumes "\<Gamma>;\<Delta> \<turnstile> e : \<tau>"
  and "S;e \<hookrightarrow> S';e'"
  and "\<Turnstile> S : \<Gamma>;\<Delta>"
  shows "\<exists> \<Gamma>' \<Delta>'. (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK \<and> \<Turnstile> S' : (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and> (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')  \<turnstile> e' : \<tau>"
proof -
  have "\<Gamma>;\<Delta> \<Turnstile> OK" and "\<Delta> \<Turnstile> \<tau>" and "\<Delta> \<Turnstile> TY"
    using prems ty_wf_env ty_wf_type ty_wf_env_ty by auto
  from prems this show ?thesis proof (induct arbitrary: e' S S')
    case (t_unit \<Delta> \<Gamma> e' S S')
    have "S;TmUnit \<hookrightarrow> S';e'" .
    thus ?case proof (cases)
      case (e_val S v z)
      have Hgok: "\<Gamma>;\<Delta> \<Turnstile> OK" using prems by (auto simp add: ty_wf_env)
      moreover have "z \<notin> dom \<Gamma>" using prems by (auto simp add: store_dom_not_in)
      ultimately have Hok: "\<Gamma>,(z:TyUnit);\<Delta> \<Turnstile> OK" using prems by (auto simp add: wf_env_weakening)
      moreover
      have "\<Turnstile> S,(z\<mapsto>TmUnit) : \<Gamma>,(z:TyUnit);\<Delta>"
        using prems store_typing_cons[of S \<Gamma> _ TmUnit TyUnit] by auto
      moreover
      have "\<Gamma>,(z:TyUnit);\<Delta> \<turnstile> TmFreeVar z : TyUnit" using Hok t_var by auto
      ultimately
      have "\<Gamma>,(z:TyUnit);\<Delta> \<Turnstile> OK \<and> \<Turnstile> S,(z\<mapsto>TmUnit) : \<Gamma>,(z:TyUnit);\<Delta>
            \<and> \<Gamma>,(z:TyUnit);\<Delta> \<turnstile> TmFreeVar z : TyUnit"
        by blast
      thus ?thesis using e_val 
        by (auto simp add: exI[of _ "{(z\<rhd>TyUnit)}"] exI[of _ "{}"])
    qed auto
  next
    case (t_var \<Delta> \<Gamma> \<tau> x e' S S')
    have "S;TmFreeVar x \<hookrightarrow> S';e'" .
    thus ?case by (cases, auto)
  next
    case (t_abs L \<Delta> \<Gamma> \<tau>1 \<tau>2 eb e' S S')
    have H: "\<forall>x. \<not> x free in eb \<and> x \<notin> L \<and> \<not> \<Gamma> defines x \<longrightarrow> \<Gamma>,(x:\<tau>1);\<Delta> \<turnstile> freshen_tm x eb : \<tau>2"
      using prems by blast
    have H': "\<Gamma>;\<Delta> \<Turnstile> OK" by assumption
    have H'': "\<Delta> \<Turnstile> \<tau>1\<rightarrow>\<tau>2" by assumption
    have "S;\<lambda>[\<tau>1].eb \<hookrightarrow> S';e'" .
    thus ?case proof cases
      case (e_val S v z)
      hence Hok: "\<Gamma>,(z:\<tau>1\<rightarrow>\<tau>2);\<Delta> \<Turnstile> OK" using prems H' H'' store_dom_not_in wf_env_weakening[of \<Gamma> \<Delta> z "\<tau>1\<rightarrow>\<tau>2"] by auto
      from store_typing_cons have "\<Turnstile> S,(z\<mapsto>\<lambda>[\<tau>1].eb) : \<Gamma>,(z:\<tau>1\<rightarrow>\<tau>2);\<Delta>" using H prems by blast
      moreover
      hence "\<Gamma>,(z:\<tau>1\<rightarrow>\<tau>2);\<Delta> \<turnstile> TmFreeVar z : \<tau>1\<rightarrow>\<tau>2" using Hok t_var by auto
      ultimately
      have "\<Gamma>,(z:\<tau>1\<rightarrow>\<tau>2);\<Delta> \<Turnstile> OK \<and> \<Turnstile> S,(z\<mapsto>\<lambda>[\<tau>1].eb) : \<Gamma>,(z:\<tau>1\<rightarrow>\<tau>2);\<Delta> \<and>
              \<Gamma>,(z:\<tau>1\<rightarrow>\<tau>2);\<Delta> \<turnstile> TmFreeVar z : \<tau>1\<rightarrow>\<tau>2" by auto
      thus ?thesis using prems 
        by (auto simp add:  exI[of _ "{(z\<rhd>\<tau>1\<rightarrow>\<tau>2)}"] exI[of _ "{}"])
    qed auto
  next
    case (t_app \<Delta> \<Gamma> \<tau>1 \<tau>2 e1 e2 e' S S')
    have H: "\<Gamma>;\<Delta> \<turnstile> e1 : \<tau>1 \<rightarrow> \<tau>2" .
    have H': "\<Gamma>;\<Delta> \<turnstile> e2 : \<tau>1" .
    have H'': "\<Delta> \<Turnstile> \<tau>1 \<rightarrow> \<tau>2" using prems ty_wf_type by auto
    have "S;e1 \<cdot> e2 \<hookrightarrow> S';e'" .
    thus ?case using H H' H'' proof cases
      case (e_app_p1 S S' e1 e1')
      have "\<exists>\<Gamma>' \<Delta>'. (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK \<and> \<Turnstile> S':(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and>
        (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> e1' : (\<tau>1 \<rightarrow> \<tau>2)" using prems H'' by auto
      then obtain \<Gamma>' \<Delta>' where "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK \<and> \<Turnstile> S':(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and>
        (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> e1' : \<tau>1 \<rightarrow> \<tau>2" by blast
      moreover
      have "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK" using prems by blast
      hence "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> e2 : \<tau>1" using t_app.hyps weakening[of _ _ _ _ \<Gamma>' \<Delta>'] by auto
      ultimately
      show ?thesis using prems by auto
    next
      case (e_app_p2 S S' e2 e2' z)
      have "\<exists>\<Gamma>' \<Delta>'. (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK \<and> \<Turnstile> S':(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and> (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> e2' : \<tau>1"
        using prems H'' by auto
      then obtain \<Gamma>' \<Delta>' where "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK \<and> \<Turnstile> S':(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and>
                                (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> e2' : \<tau>1" by blast
      moreover
      hence "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> (TmFreeVar z) : \<tau>1 \<rightarrow> \<tau>2"
        using prems weakening[of _ _ _ _ \<Gamma>' \<Delta>'] by auto
      ultimately
      show ?thesis using prems by auto
    next
      case (e_beta S \<tau> e1 y)
      hence "\<Gamma>;\<Delta> \<turnstile> \<lambda>[\<tau>]. e1 : \<tau>1 \<rightarrow> \<tau>2"
        using prems store_typing_elim[of S \<Gamma> _ _ "\<lambda>[\<tau>].e1" "\<tau>1\<rightarrow>\<tau>2"] by auto
      moreover hence Heq: "\<tau> = \<tau>1" by auto
      ultimately have Ht: "\<Gamma>;\<Delta> \<turnstile> \<lambda>[\<tau>1]. e1 : \<tau>1 \<rightarrow> \<tau>2" by auto
      hence Hy: "\<Gamma>;\<Delta> \<turnstile> TmFreeVar y : \<tau>1" using prems by auto
      have "\<Gamma>;\<Delta> \<turnstile> vsubst_tm (TmFreeVar y) 0 e1 : \<tau>2" using Ht proof
        fix L \<tau>2a
        assume "finite L"
          and "\<Delta> \<Turnstile> \<tau>1"
          and Hl: "\<forall>x. x \<notin> set (free_tm e1) \<and> x \<notin> L \<and> x \<notin> dom \<Gamma> \<longrightarrow>
          \<Gamma>,(x:\<tau>1);\<Delta> \<turnstile> vsubst_tm (TmFreeVar x) 0 e1 : \<tau>2a"
          and "\<tau>1 \<rightarrow> \<tau>2 = \<tau>1 \<rightarrow> \<tau>2a"
        moreover have "finite (dom \<Gamma>)" using wf_env_fin prems by auto
        hence "finite (L \<union> dom \<Gamma>)" by auto
        ultimately
        obtain k where Hk: "\<not> k free in e1 \<and> k \<notin> L \<and> k \<notin> dom \<Gamma>"
          using fresh_exists[of "L \<union> dom \<Gamma> \<union> set (free_tm e1)"] by auto
        moreover have "\<tau>2 = \<tau>2a" using prems by auto
        ultimately have "\<Gamma>,(k:\<tau>1);\<Delta> \<turnstile> freshen_tm k e1 : \<tau>2" using Hl by auto
        thus "\<Gamma>;\<Delta> \<turnstile> vsubst_tm (TmFreeVar y) 0 e1 : \<tau>2"
          using substitution[of e1 _ \<Gamma> _ "TmFreeVar y" \<tau>1 k "0" \<tau>2] Hk Hy by auto
      qed
      hence "\<Gamma>;\<Delta> \<Turnstile> OK \<and> \<Turnstile> S:\<Gamma>;\<Delta> \<and> \<Gamma>;\<Delta> \<turnstile> vsubst_tm (TmFreeVar y) 0 e1 : \<tau>2"
        using prems by auto
      thus ?thesis using prems by (auto simp add: exI[of _ "{}"])
    qed auto
  next
    case (t_poly L \<Delta> \<Gamma> \<tau> v e' S S')
    have H: "\<forall>x. \<not> x free in term v \<and> \<not> x free in type \<tau> \<and> x \<notin> L \<and> x \<notin> free_ty_env \<Gamma> \<and> x \<notin> dom \<Delta> \<longrightarrow>
             \<Gamma>;\<Delta>,(x:\<star>) \<turnstile> freshen_tmty x v : freshen_ty x \<tau>"
      using prems by blast
    have H': "\<Gamma>;\<Delta> \<Turnstile> OK" by assumption
    have H'': "\<Delta> \<Turnstile> \<forall>.\<tau>" by assumption
    have H''': "value v" by assumption
    have "S;\<Lambda>[*].v \<hookrightarrow> S';e'" .
    thus ?case proof cases
      case (e_val S va z)
      hence "z \<notin> dom \<Gamma>" using prems by (auto simp add: store_dom_not_in)
      hence Hok: "\<Gamma>,(z:\<forall>.\<tau>);\<Delta> \<Turnstile> OK" using H' H'' wf_env_weakening by auto
      have "\<Turnstile> S,(z\<mapsto>\<Lambda>[*].v) : \<Gamma>,(z:\<forall>.\<tau>);\<Delta>" using H  store_typing_cons[of S \<Gamma> \<Delta> "\<Lambda>[*].v" _ z] using prems by blast
      moreover
      hence "\<Gamma>,(z:\<forall>.\<tau>);\<Delta> \<turnstile> TmFreeVar z : \<forall>.\<tau>" using Hok t_var by auto
      ultimately
      have "\<Gamma>,(z:\<forall>.\<tau>);\<Delta> \<Turnstile> OK \<and> \<Turnstile> S,(z\<mapsto>\<Lambda>[*].v) : \<Gamma>,(z:\<forall>.\<tau>);\<Delta> \<and> \<Gamma>,(z:\<forall>.\<tau>);\<Delta> \<turnstile> TmFreeVar z : \<forall>.\<tau>"
        by auto
      thus ?thesis using e_val by (auto simp add:  exI[of _ "{(z\<rhd>\<forall>.\<tau>)}"] exI[of _ "{}"])
    qed auto
  next
    case (t_tyapp \<Delta> \<Gamma> \<tau> \<tau>1 e1 e' S S')
    have H: "\<Gamma>;\<Delta> \<turnstile> e1 : \<forall>.\<tau>1" .
    have H': "\<Delta> \<Turnstile> \<forall>.\<tau>1" using prems ty_wf_type by auto
    have H'': "\<Delta> \<Turnstile> \<tau>" using prems by auto
    have "S;e1 \<langle>\<tau>\<rangle> \<hookrightarrow> S';e'" .
    thus ?case using H H' H'' proof cases
      case (e_tyapp_p S S' \<tau> e e1')
      have "\<exists>\<Gamma>' \<Delta>'. (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK \<and> \<Turnstile> S':(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and>
        (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> e1' : \<forall>.\<tau>1" using prems H' by auto
      then obtain \<Gamma>' \<Delta>' where "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK \<and> \<Turnstile> S':(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and>
        (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> e1' : \<forall>.\<tau>1" by blast
      moreover
      have "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK" using prems by blast
      moreover
      hence "(\<Delta>\<union>\<Delta>') \<Turnstile> TY" using wf_env_wf_env_ty by auto
      hence "(\<Delta>\<union>\<Delta>') \<Turnstile> \<tau>" using ok_weakening_ty_union prems ty_wf_type by auto
      hence "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> e1' \<langle>\<tau>\<rangle> : vsubst_ty \<tau> 0 \<tau>1" using prems by auto
      ultimately
      show ?thesis using e_tyapp_p by blast
    next
      case (e_tybeta Sa _ e z)
      hence "Sa = S" by auto
      have "z\<rhd> \<forall>.\<tau>1 \<in> \<Gamma>" using prems by auto
      hence Ht: "\<Gamma>;\<Delta> \<turnstile> \<Lambda>[*]. e : \<forall>.\<tau>1"
        using prems store_typing_elim[of S \<Gamma> \<Delta> z _ "\<forall>.\<tau>1"] by auto
      have "S \<Turnstile> Store" using prems store_ty_store by auto
      hence "value (\<Lambda>[*].e)" using prems store_ok_is_value by auto
      hence Hv: "value e" by auto
      have "\<Gamma>;\<Delta> \<turnstile> vsubst_tmty \<tau> 0 e : vsubst_ty \<tau> 0 \<tau>1" using Ht proof
        fix La \<tau>x
        assume "finite La"
          and "value e"
          and "\<forall>x. x \<notin> set (free_tmty e) \<and> x \<notin> set (free_ty \<tau>x) \<and> x \<notin> La \<and> x \<notin> free_ty_env \<Gamma> \<and> x \<notin> Environ.dom \<Delta> \<longrightarrow>
               \<Gamma>;\<Delta>,(x:\<star>) \<turnstile> vsubst_tmty (TyFreeVar x) 0 e : vsubst_ty (TyFreeVar x) 0 \<tau>x"
          and "\<forall>.\<tau>1 = \<forall>.\<tau>x"
        have "\<tau>1 = \<tau>x" using prems by auto
        have "\<Gamma>;\<Delta> \<Turnstile> OK" using ty_wf_env prems by auto
        hence "finite (free_ty_env \<Gamma>)" using free_env_finite wf_env_def prems by auto
        moreover
        have "finite (dom \<Delta>)" using prems wf_env_ty_fin by auto
        moreover
        have "finite La" using prems by auto
        ultimately
        obtain k
          where Hk: "k \<notin> set (free_tmty e) \<and> k \<notin> set (free_ty \<tau>x) \<and> k \<notin> La \<and>
          k \<notin> free_ty_env \<Gamma> \<and> k \<notin> Environ.dom \<Delta>"
          using fresh_exists[of "set (free_tmty e) \<union> set (free_ty \<tau>x) \<union> La \<union>
            free_ty_env \<Gamma> \<union> dom \<Delta>"] by auto
        have Ht': "\<Gamma>;\<Delta>,(k:\<star>) \<turnstile> freshen_tmty k e : freshen_ty k \<tau>x"
          using prems by auto
        hence "\<Gamma>;\<Delta>,(k:\<star>) \<Turnstile> OK" using ty_wf_env by auto
        hence"\<Gamma> = vsubst_ty_env (TyFreeVar k) 0 \<Gamma>" and Hn1: "\<Gamma> = vsubst_ty_env \<tau> 0 \<Gamma>"
          using wf_env_subst_eq[of \<Gamma> _ \<tau>] wf_env_subst_eq[of \<Gamma> "\<Delta>,(k:\<star>)" "TyFreeVar k"] by auto
        hence  "vsubst_ty_env (TyFreeVar k) 0 \<Gamma>;\<Delta>,(k:\<star>) \<turnstile> freshen_tmty k e : freshen_ty k \<tau>x"
          using Ht' by auto
        moreover
        have "vsubst_ty_env \<tau> 0 \<Gamma>;\<Delta> \<Turnstile> OK" using Hn1 using prems by auto
        ultimately
        have "vsubst_ty_env \<tau> 0 \<Gamma>;\<Delta> \<turnstile> vsubst_tmty \<tau> 0 e : vsubst_ty \<tau> 0 \<tau>1"
          using prems substitution_ty[of e _ \<tau> 0 \<Gamma> \<Delta> k \<tau>x] by auto
        thus "\<Gamma>;\<Delta> \<turnstile> vsubst_tmty \<tau> 0 e : vsubst_ty \<tau> 0 \<tau>1"
          using Hn1 by auto
      qed 
      thus ?thesis using prems by (auto simp add: exI[of _ "{}"])
    qed auto
  next
    case (t_new \<Delta> \<Gamma> \<tau> e ef' S S')
    have Ht: "\<Gamma>;\<Delta> \<turnstile> e : \<tau>" .
    have "S; TmNew e \<hookrightarrow> S'; ef'" .
    thus ?case using Ht proof cases
      case (e_new_p S S' e e')
      hence H: "\<exists>\<Gamma>' \<Delta>'. (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<Turnstile> OK \<and> \<Turnstile> S': (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and> (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> e': \<tau>"
        using prems by auto
      then obtain \<Gamma>' \<Delta>'
        where "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<Turnstile> OK \<and> \<Turnstile> S': (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and> (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<turnstile> e': \<tau>"
        by blast
      thus ?thesis using e_new_p by auto
    next
      case (e_new_c S v x z)
      let ?\<Gamma>' = "{(z\<rhd>\<tau>)}"
      have "\<not> \<Gamma> defines z" using prems by (auto simp add: store_dom_not_in)
      moreover have "\<Gamma>;\<Delta> \<Turnstile> OK" using prems by (auto simp add: ty_wf_env)
      ultimately have Hok: "(\<Gamma> \<union> ?\<Gamma>');\<Delta>  \<Turnstile> OK" using prems wf_env_weakening by auto
      moreover
      {
        have "S \<Turnstile> Store" using prems store_ty_store by auto
        hence "value v" using prems store_ok_is_value by auto
        moreover
        have "\<Gamma>;\<Delta>  \<turnstile> v : \<tau>" using prems store_typing_elim by auto
        ultimately
        have "\<Turnstile> S,(z\<mapsto>v):(\<Gamma> \<union> ?\<Gamma>');\<Delta> " using prems store_typing_cons by auto
      }
      moreover
      have "(\<Gamma> \<union> ?\<Gamma>');\<Delta>  \<turnstile> TmLoc z : TyRef \<tau>" using Hok by blast
      ultimately
      show ?thesis using e_new_c by (auto simp add: exI[of _ ?\<Gamma>'] exI[of _ "{}"])
    qed auto
  next
    case (t_assign \<Delta> \<Gamma> \<tau> e1 e2 ef' S S')
    have H1: "\<Gamma>;\<Delta> \<turnstile> e1 : TyRef \<tau>" .
    have H2: "\<Gamma>;\<Delta> \<turnstile> e2 : \<tau>" .
    have H3: "\<Delta> \<Turnstile> TyRef \<tau>" using prems ty_wf_type by auto
    have "S; e1 := e2 \<hookrightarrow> S'; ef'" .
    thus ?case using H1 H2 H3 proof cases
      case (e_assign_p1 S S' e1 e1')
      have H: "\<exists>\<Gamma>' \<Delta>'. (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK \<and> \<Turnstile> S':(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and> (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<turnstile> e1': TyRef \<tau>"
        using prems H3 by auto
      then obtain \<Gamma>' \<Delta>'
        where "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK \<and> \<Turnstile> S':(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and> (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<turnstile> e1': TyRef \<tau>" by auto
      moreover
      have "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<turnstile> e2 : \<tau>" using prems by (auto simp add: weakening)
      ultimately
      show ?thesis using e_assign_p1 by auto
    next
      case (e_assign_p2 S S' e2 e2' x)
      have H: "\<exists>\<Gamma>' \<Delta>'. (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK \<and> \<Turnstile> S':(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and> (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<turnstile> e2': \<tau>"
        using prems H3 by auto
      then obtain \<Gamma>' \<Delta>' where "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<Turnstile> OK \<and> \<Turnstile> S':(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and> (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<turnstile> e2': \<tau>"
        using prems by blast
      moreover
      hence "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<turnstile>TmFreeVar x: TyRef \<tau>" using weakening[of \<Gamma> \<Delta> _ _ \<Gamma>' \<Delta>'] prems by auto
      ultimately
      show ?thesis using e_assign_p2 by auto
    next
      case (e_assign_c S l v x y)
      have "\<Gamma>;\<Delta> \<turnstile>TmUnit:TyUnit" using prems by auto
      moreover
      {
        have "(x\<rhd>TyRef \<tau>) \<in> \<Gamma>" using prems by auto
        hence "\<Gamma>;\<Delta> \<turnstile> TmLoc l : TyRef \<tau>" using store_typing_elim using prems by auto
        hence "\<Gamma>;\<Delta> \<turnstile> TmFreeVar l : \<tau>" by auto
        moreover
        have "\<Gamma>;\<Delta> \<turnstile> v : \<tau>" using prems store_typing_elim by auto
        moreover
        have "S \<Turnstile> Store" using prems store_ty_store by auto
        hence "value v" using prems store_ok_is_value by auto
        ultimately
        have "\<Turnstile> update S l v: \<Gamma>;\<Delta>" using prems st_ty_update[of S \<Gamma> \<Delta> l _ v] by (auto simp add: dom_def)
      }
      ultimately
      show ?thesis using prems by (auto simp add: exI[of _ "{}"])
    qed auto
  next
    case (t_deref \<Delta> \<Gamma> \<tau> e ef' S S')
    have Ht: "\<Gamma>;\<Delta> \<turnstile> e : TyRef \<tau>" .
    have Hty: "\<Delta> \<Turnstile> TyRef \<tau>" using prems ty_wf_type by auto
    have "S; TmDeref e \<hookrightarrow> S'; ef'" .
    thus ?case using Ht
    proof cases
      case (e_deref_p S S' e e')
      have "\<exists>\<Gamma>' \<Delta>'. (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<Turnstile> OK \<and> \<Turnstile> S' : (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and>  (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<turnstile> e': TyRef \<tau>"
        using prems Hty by auto
      then obtain \<Gamma>' \<Delta>'
        where  "(\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<Turnstile> OK \<and> \<Turnstile> S' : (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>') \<and>  (\<Gamma>\<union>\<Gamma>');(\<Delta>\<union>\<Delta>')\<turnstile> e': TyRef \<tau>" by auto
      thus ?thesis using e_deref_p by auto
    next
      case (e_deref_c S l v z)
      have "(z\<rhd>TyRef \<tau>) \<in> \<Gamma>" using prems by auto
      hence "\<Gamma>;\<Delta> \<turnstile> TmLoc l : TyRef \<tau>" using prems store_typing_elim by auto
      hence "\<Gamma>;\<Delta> \<turnstile> ef' : \<tau>" using prems store_typing_elim[of _ _ _ l ef'] by auto
      hence "\<Gamma>;\<Delta> \<Turnstile> OK \<and> \<Turnstile> S:\<Gamma>;\<Delta> \<and> \<Gamma>;\<Delta> \<turnstile> ef' :\<tau>" using prems by auto
      thus ?thesis using e_deref_c by (auto simp add: exI[of _ "{}"])
    qed auto
  next
    case (t_loc \<Delta> \<Gamma> \<tau> l e' S S')
    have "l\<rhd>\<tau> \<in> \<Gamma>" .
    moreover have "\<Gamma>;\<Delta> \<Turnstile> OK" .
    ultimately have Ht: "\<Gamma>;\<Delta> \<turnstile> TmFreeVar l : \<tau>" by auto
    let ?\<Gamma>' = "{z\<rhd>(TyRef \<tau>)}"
    have "S;TmLoc l \<hookrightarrow> S';e'" .
    thus ?case using Ht proof cases
      case (e_val S v z)
      have "z \<notin> dom \<Gamma>" using prems by (auto simp add: store_dom_not_in)
      hence Hok: "\<Gamma>,(z:TyRef \<tau>);\<Delta> \<Turnstile> OK" using prems by (auto simp add: wf_env_weakening)
      moreover
      have "\<Turnstile> S,(z\<mapsto>TmLoc l) : \<Gamma>,(z:TyRef \<tau>);\<Delta> " using prems store_typing_cons[of S \<Gamma> \<Delta> "TmLoc l"] by auto
      moreover
      have "(z\<rhd>TyRef \<tau>) \<in> \<Gamma>,(z:TyRef \<tau>)" by auto
      hence "\<Gamma>,(z:TyRef \<tau>);\<Delta> \<turnstile> TmFreeVar z : TyRef \<tau>" using Hok using t_var by auto
      ultimately
      have "\<Gamma>,(z:TyRef \<tau>);\<Delta> \<Turnstile> OK \<and> \<Turnstile> S,(z\<mapsto>TmLoc l) : \<Gamma>,(z:TyRef \<tau>);\<Delta>  \<and> \<Gamma>,(z:TyRef \<tau>);\<Delta>  \<turnstile> TmFreeVar z : TyRef \<tau>"
        by auto
    thus ?thesis using e_val by (auto simp add: exI[of _ "{z\<rhd>TyRef \<tau>}"] exI[of _ "{}"])
  qed auto
qed
qed

theorem progress:
  assumes Ht: "\<Gamma>;\<Delta> \<turnstile> e : \<tau>"
  and "\<Turnstile> S : \<Gamma>;\<Delta>"
  shows "not_stuck e S"
proof -
  { fix \<Gamma>
    assume "\<Gamma>;\<Delta> \<turnstile> e : \<tau>"
      and "\<Turnstile> S : \<Gamma>;\<Delta>"
    hence "not_stuck e S" proof induct
      case (t_unit \<Gamma>)
      have "S \<Turnstile> Store" using prems by (auto simp add: store_ty_store)
      moreover
      have "value TmUnit" by auto
      moreover
      obtain z where "z \<notin> dom S"
        using prems fresh_exists[of "dom S"] by (auto simp add: dom_finite store_ty_finite)
      ultimately
      have "S;TmUnit \<hookrightarrow> S,(z\<mapsto>TmUnit);TmFreeVar z" by auto
      thus ?case by auto
    next
      case (t_var \<Gamma> \<tau> x) thus ?case by auto
    next
      case (t_abs L \<Delta> \<Gamma> \<tau>1 \<tau>2 e_b)
      have "S \<Turnstile> Store" using prems by (auto simp add: store_ty_store)
      moreover
      have "value (\<lambda>[\<tau>1]. e_b)" by auto
      moreover
      obtain z where "z \<notin> dom S"
        using prems fresh_exists[of "dom S"] by (auto simp add: dom_finite store_ty_finite)
      ultimately
      have "S;(\<lambda>[\<tau>1]. e_b) \<hookrightarrow> S,(z\<mapsto>(\<lambda>[\<tau>1]. e_b));TmFreeVar z" by auto
      thus ?case by auto
    next
      case (t_app \<Delta> \<Gamma> \<tau>1 \<tau>2 e1 e2)
      from t_app have "isVar e1 \<or> makes_progress e1 S" by auto
      thus ?case proof
        assume V1: "isVar e1"
        from t_app have "isVar e2 \<or> makes_progress e2 S" by auto
        thus ?case proof
          assume V2: "isVar e2" thus ?case proof
            obtain x where Hx: "e1 = TmFreeVar x" by (rule isVar_var_elim)
            moreover
            obtain y where Hy: "e2 = TmFreeVar y" by (rule isVar_var_elim)
            ultimately
            have "S \<Turnstile> Store" using prems by (auto simp add: store_ty_store)
            moreover
            {
              have "x \<in> dom \<Gamma>" using Hx t_app by (auto simp add: dom_def)
              hence "x \<in> dom S" using t_app by (auto simp add: store_dom_in)
            }
            ultimately
            obtain v where "(x\<mapsto>v) \<in> S \<and> value v" using store_ok_exists_value by auto
            from store_typing_elim have "\<Gamma>;\<Delta> \<turnstile> v : \<tau>1 \<rightarrow> \<tau>2" using prems by auto
            then  obtain tm where "v = \<lambda>[\<tau>1]. tm" using canonical_form_abs prems by auto
            hence "S;x\<Down>\<lambda>[\<tau>1]. tm" using prems by auto
            hence "S;TmFreeVar x \<cdot> TmFreeVar y \<hookrightarrow> S;freshen_tm y tm" ..
            hence "\<exists>e' S'. S;TmFreeVar x \<cdot> TmFreeVar y \<hookrightarrow> S';e'"
              using exI[of _ "freshen_tm y tm"] exI[of _ S] by auto
            thus ?thesis using Hx Hy by auto
          qed
        next
          assume "makes_progress e2 S"
          then obtain e2' S' \<mu>' where "S;e2 \<hookrightarrow> S';e2'" by auto
          hence "S;(e1 \<cdot> e2) \<hookrightarrow> S';(e1 \<cdot> e2')" using V1 by auto
          thus "not_stuck (e1 \<cdot> e2) S" using prems by auto
        qed
      next
        assume "makes_progress e1 S"
        then obtain e1' S' \<mu>' where "S;e1 \<hookrightarrow> S';e1'" by auto
        hence "S;(e1 \<cdot> e2) \<hookrightarrow> S';(e1' \<cdot> e2)" by auto
        hence "makes_progress (e1 \<cdot> e2) S"
          using exI[of _ S'] exI[of _ "e1' \<cdot> e2"] by auto
        thus "not_stuck (e1 \<cdot> e2) S" by auto
      qed
    next
      case (t_new \<Delta> \<Gamma> \<tau> e)
      from t_new have "isVar e \<or> makes_progress e S" by auto
      thus ?case proof
        assume "isVar e"
        obtain x where Hx: "e = TmFreeVar x" by (rule isVar_var_elim)
        have "finite S" using prems store_ty_finite by auto
        then obtain z where "\<not> S defines z" using fresh_exists[of "dom S"] by (auto simp add: dom_finite)
        have "\<Gamma> defines x" using prems by (auto simp add: dom_def)
        hence "S defines x" using prems by (auto simp add: store_dom_in)
        then obtain v where "(x\<mapsto>v) \<in> S"
          using prems store_ok_exists_value[of S x] store_ty_store by auto
        hence  "S;TmNew (TmFreeVar x) \<hookrightarrow> S,(z\<mapsto>v);TmLoc z" using prems Hx by auto
        thus ?case using Hx using exI[of _ "S,(z\<mapsto>v)"] exI[of _ "TmLoc z"] by auto
      next
        assume "makes_progress e S"
        then obtain e' S' where "S;e \<hookrightarrow> S';e'" by auto
        hence "S;TmNew e \<hookrightarrow> S';TmNew e'" by auto
        thus ?case by auto
      qed
    next
      case (t_assign \<Delta> \<Gamma> \<tau> e1 e2)
      from t_assign have "isVar e1 \<or> makes_progress e1 S" by auto
      thus ?case proof
        assume "makes_progress e1 S"
        then obtain e1' S' where "S;e1 \<hookrightarrow> S';e1'" by auto
        hence "S;e1 := e2 \<hookrightarrow> S';e1' := e2" by auto
        thus ?case by auto
      next
        assume "isVar e1"
        then obtain x where Hx: "e1 = TmFreeVar x" by (rule isVar_var_elim)
        from t_assign have "isVar e2 \<or> makes_progress e2 S" by auto
        thus ?case proof
          assume "makes_progress e2 S"
          then obtain e2' S' where "S;e2 \<hookrightarrow> S';e2'" by auto
          hence "S;TmAssign (TmFreeVar x) e2 \<hookrightarrow> S';TmAssign (TmFreeVar x) e2'" by auto
          thus ?case using Hx by auto
        next
          assume "isVar e2"
          obtain y where Hy: "e2 = TmFreeVar y" by (rule isVar_var_elim)
          have H: "S \<Turnstile> Store" using prems by (auto simp add: store_ty_store)
          moreover
          have "x \<in> dom \<Gamma>" using Hx t_assign by (auto simp add: dom_def)
          hence "x \<in> dom S" using t_assign store_dom_in by auto
          ultimately
          obtain v where "(x\<mapsto>v) \<in> S \<and> value v" using store_ok_exists_value by auto
          from store_typing_elim have "\<Gamma>;\<Delta> \<turnstile> v : TyRef \<tau> " using prems by auto
          then obtain l where "v = TmLoc l" using canonical_form_loc prems by auto
          have "\<Gamma> defines y" using prems by (auto simp add: dom_def)
          hence "S defines y" using store_dom_in prems by auto
          then obtain v' where "(y\<mapsto>v') \<in> S"
            using prems H store_ok_exists_value[of S y] by (auto simp add: dom_def)
          hence "S;TmFreeVar x := TmFreeVar y \<hookrightarrow> update S l v';TmUnit" using prems by auto
          hence "\<exists>e' S'. S;TmFreeVar x := TmFreeVar y\<hookrightarrow>S';e'"
            using exI[of _ "update S l v'"] exI[of _ TmUnit] by auto
          hence "makes_progress (TmAssign (TmFreeVar x) (TmFreeVar y)) S" by auto
          thus ?thesis using prems by auto
        qed
      qed
    next
      case (t_deref \<Delta> \<Gamma> \<tau> e)
      from t_deref have "isVar e \<or> makes_progress e S" by auto
      thus ?case proof
        assume "isVar e"
        then obtain x where Hx: "e = TmFreeVar x" by auto
        have "S \<Turnstile> Store" using prems by (auto simp add: store_ty_store)
        moreover
        have "x \<in> dom \<Gamma>" using Hx t_deref by (auto simp add: dom_def)
        hence "x \<in> dom S" using t_deref store_dom_in by auto
        ultimately
        obtain v where A: "(x\<mapsto>v) \<in> S \<and> value v" using store_ok_exists_value by auto
        from store_typing_elim have B: "\<Gamma>;\<Delta> \<turnstile> v : TyRef \<tau> " using prems by auto
        then obtain l where C: "v = TmLoc l" using canonical_form_loc prems by auto
        hence "\<Gamma> defines l" using B by (auto simp add: dom_def)
        hence "S defines l" using store_dom_in prems by auto
        then obtain v' where "(l\<mapsto>v') \<in> S \<and> value v'"
          using store_ok_exists_value prems store_ty_store[of S] by blast
        hence "S;x\<Down>TmLoc l" and "S;l\<Down>v'" using A B C by auto
        hence "S;TmDeref (TmFreeVar x) \<hookrightarrow> S; v'" using A prems using e_deref_c[of x S v'] by auto
        hence "makes_progress (TmDeref (TmFreeVar x)) S"
          using exI[of _ S] exI[of _ v'] by auto
        hence "\<exists>e' S'. S;TmDeref (TmFreeVar x)\<hookrightarrow>S';e'" by auto
        thus ?thesis using prems by auto
      next
        assume "makes_progress e S"
        then obtain e' S' where "S;e \<hookrightarrow> S';e'" by auto
        hence "S;TmDeref e \<hookrightarrow> S'; TmDeref e'" by auto
        thus ?case using exI[of _ S'] exI[of _ "TmDeref e'"] by auto
      qed
    next
      case (t_loc \<Delta> \<Gamma> \<tau> l)
      have "S \<Turnstile> Store" using prems by (auto simp add: store_ty_store)
      moreover
      have "value (TmLoc l)" by auto
      moreover
      obtain z where "z \<notin> dom S"
        using prems fresh_exists[of "dom S"] by (auto simp add: dom_finite store_ty_finite)
      ultimately
      have "S;(TmLoc l) \<hookrightarrow> S,(z\<mapsto>(TmLoc l));TmFreeVar z" by auto
      thus ?case by auto
    next
      case (t_poly L \<Delta> \<Gamma> \<tau> v)
      show ?case proof (cases "value v")
        assume "value v"
        have "S \<Turnstile> Store" using prems by (auto simp add: store_ty_store)
        moreover
        have "value (\<Lambda>[*].v)" using prems by auto
        moreover
        obtain z where "z \<notin> dom S"
          using prems fresh_exists[of "dom S"] by (auto simp add: dom_finite store_ty_finite)
        ultimately
        have "S;(\<Lambda>[*].v) \<hookrightarrow> S,(z\<mapsto>(\<Lambda>[*].v));TmFreeVar z" by auto
        thus ?case by auto
      next
        assume "\<not> value v"
        thus ?case by contradiction
      qed
    next
      case (t_tyapp \<Delta> \<Gamma> \<tau> \<tau>1 e)
      from t_tyapp have "isVar e \<or> makes_progress e S" by auto
      thus ?case proof
        assume "makes_progress e S"
        then obtain e' S' where "S;e \<hookrightarrow> S';e'" by auto
        hence "S;e\<langle>\<tau>\<rangle> \<hookrightarrow> S';e'\<langle>\<tau>\<rangle>" by auto
        thus ?case using exI[of _ S'] exI[of _ "e'\<langle>\<tau>\<rangle>"] by auto
      next
        assume "isVar e"
        then obtain x where Hx: "e = TmFreeVar x" by auto
        have "S \<Turnstile> Store" using prems by (auto simp add: store_ty_store)
        moreover
        have "x \<in> dom \<Gamma>" using Hx t_tyapp by (auto simp add: dom_def)
        hence "x \<in> dom S" using t_tyapp store_dom_in by auto
        ultimately
        obtain v where "(x\<mapsto>v) \<in> S \<and> value v" using store_ok_exists_value by auto
        moreover
        from store_typing_elim have "\<Gamma>;\<Delta> \<turnstile> v : \<forall>. \<tau>1" using prems by auto
        then obtain w where "v = \<Lambda>[*].w" using canonical_form_tyabs prems by auto
        ultimately
        have "S;x\<Down>(\<Lambda>[*].w)" using prems by auto
        hence "S;e\<langle>\<tau>\<rangle> \<hookrightarrow> S; vsubst_tmty \<tau> 0 w" using e_tybeta Hx by auto
        thus ?case using exI[of _ S] exI[of _ "vsubst_tmty \<tau> 0 w"] by auto
    qed
  qed
  }
  with prems show ?thesis by auto
qed

end
